@echo off
setlocal enabledelayedexpansion enableextensions

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	if "%~1" neq "" goto :SETUP
goto :END


:SETUP
rem @echo :SETUP %*
	set bat_delim=\
	set bat_arg1=%~1


	set bat_arg2_subdir=%~2

	set bat_returncode=0

	set bat_targetdir=!cd!::
	set bat_targetdir=!bat_targetdir:\::=!
	set bat_targetdir=!bat_targetdir:::=!
	set bat_targetdir_save=!bat_targetdir!

	echo.%*|find /i "*">nul
	if !errorlevel! equ 0 goto :CMDARGS1

	PUSHD "%~1">null 2>&1
	if !errorlevel! equ 0 (
		POPD
		echo.    ERROR 1 - Can't change date of a directory entry.
		echo.
		set bat_
		exit /b 1
	)

:CMDARGS1
	echo.================================================
	echo.[!date! !time!] %~0 %*
	echo.

	set bat_basedir=%~dp1::
	set bat_basedir=!bat_basedir:\::=!
	set bat_basedir=!bat_basedir:::=!

	call :GETFILESPEC "!bat_basedir!"


	PUSHD"!bat_basedir!"

	set bat_targetdir=!cd!::
	set bat_targetdir=!bat_targetdir:\::=!
	set bat_targetdir=!bat_targetdir:::=!

echo bat_targetdir=!bat_targetdir!

	echo.for /f "usebackq tokens=*" ..b in ^(`dir "!bat_targetdir!!bat_delim!!bat_filespec!" /a-d /b !bat_arg2_subdir!`^) do ^(
	for      /f "usebackq tokens=*" %%b in  (`dir "!bat_targetdir!!bat_delim!!bat_filespec!" /a-d /b !bat_arg2_subdir!` ) do (
		set bat_filefull=%%~fb
		set bat_filename=%%~nxb

		call :TOUCHENTRY "!bat_filefull!"

		if /i "!bat_returncode!" neq "0" (
			echo.    warning 4[!bat_returncode!] - File may be read-only, system, hidden, or locked... "!bat_filename!"
		) else (
			echo.   [!bat_filetimeold!] changed to: [!bat_filetimenew!] "!bat_targetdir!!bat_delim!!bat_filename!"
		)


	)
	popd

	echo.
goto :END


:TOUCHENTRY
rem	echo [CALL :TOUCHENTRY "%~1"]
	if "%~1" neq "" (
		if exist "%~1" (
			PUSHD "%~1">nul 2>&1
			if !errorlevel! equ 0 (
				rem If you get here, the filespec was a path without a filespec
				rem because you can't CD to a fully qualified file
				POPD
				echo.   ERROR 2 - Can't change the date of a directory entry.
				echo.
				set bat_
				exit /b 2
			) else (
				call :TOUCHFILE "%~1"
			)

		)
	)
goto :eof


:TOUCHFILE
rem	echo.[CALL :TOUCHFILE %*]
	PUSHD "%~dp1">nul 2>&1
	if !errorlevel! neq 0 (
		@echo.    ERROR 3 - Unable to change dir ["!bat_basedir!"]
		exit /b 3
	) else (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_filefull!" /b /a-d`) do (
rem			echo.........%%a
			set bat_filetimeold=%%~ta
		)
		set bat_targetdir=!cd!::
		set bat_targetdir=!bat_targetdir:\::=!
		set bat_targetdir=!bat_targetdir:::=!

		if /i "!bat_targetdir!" neq "!bat_targetdir_save!" (
			if /i "!bat_basedir!" neq "!bat_targetdir!" (
				echo.Changing directory to: "!bat_targetdir!" ["!bat_basedir!"]
				set bat_targetdir_save=!bat_targetdir!
			)
		)


		COPY /Y /b "!bat_filename!" +,,>nul: 2>&1


		set bat_returncode=!errorlevel!
		for /f "usebackq tokens=*" %%a in (`dir "!bat_filefull!" /b /a-d`) do (
rem			echo.........%%a
			set bat_filetimenew=%%~ta
		)
		POPD
		rem echo.Changing directory back to: "!cd!"
	)
goto :eof



:GETFILESPEC "!bat_basedir!"
	echo.set bat_filespec=!bat_arg1:%~1\=!
	     set bat_filespec=!bat_arg1:%~1\=!

goto :EOF



:HELP
	echo.
	echo ChangeFileDate.bat
	echo.
	echo Acts like "touch" command.  Effectively updates the file modified date 
	echo to the current date/time.  This command does not affect the "archive"
	echo attribute.  It works on single files, multiple files [using wild cards],
	echo and/or directories.  
	echo.
	echo Usage: ChangeFileDate "filespec" [/s]
	echo.
	echo   where:
	echo          filespec      Is either a file name, directory, or wildcards.
	echo                        Use quotes if there are spaces in the filespec.
	echo.
	echo          /s            Recurses through subdirs too.
	echo.
	echo Examples:
	echo           ChangeFileDate junk.txt
	echo              Changes the file date of only junk.txt to the current date/time.
	echo              Does not recurse.
	echo.
	echo           ChangeFileDate junk*.*
	echo              Changes the file date/time of all the files that match the
	echo              "junk*.*" filespec in the current directory. Does not recurse.
	echo.
	echo           ChangeFileDate *.txt *.exe *.log
	echo              Changes the file date/time of the all the ".txt" files, all
	echo              the ".exe" files, and all the ".log" files.  Does not recurse.
	echo.
	echo           ChangeFileDate junkdir\*.* /s
	echo              Recursively changes the file date/time of all the files in 
	echo              "junkdir" directory and all the files in subdirectories of
	echo              the "junkdir" directory.
	echo. 
exit /b 9
goto :END


:END
exit /b 0

