  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

		rem You must have exactly two arguments...
	if /i "%~2" equ "" (goto :HELP)


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

    if not defined bat_LOCALIZE.format.date (
    	call "!bat_exedir!\ReadParams.bat"
    )
 

	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!


	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	SET bat_returncode=0
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_coincidencedir=%~1
	set bat_targetdir=!bat_coincidencedir!

	set bat_caldir=%~2
	

goto :MAIN

	


:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN %*]

	set bat_returncode=0


	call :COPYPARAMFILES "!bat_targetdir!" "!bat_caldir!"

:MAIN_END
!bat_poplog! [END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log! :DONE
!bat_log!
goto :DONE




	rem =============================================================
	rem ====            COPYPARAMFILES                           ====
	rem 
	rem Copies the CoincidenceParameters.txt, CameraTimeOffsets, 
	rem and CameraSites.txt to the coincidence dir.
	rem
	rem Returns:
	rem     Nothing
	rem
	rem =============================================================
	
:COPYPARAMFILES
!bat_pushecho! [call !bat_batchfile!:COPYPARAMFILES %*]
	!bat_logexeclog! copy /y "!bat_exedir!\CoincidenceParameters.txt" "!bat_exedir!\Coincidence\CoincidenceParameters.txt"

	!bat_logexeclog! copy /y "!bat_exedir!\CameraTimeOffsets.txt" "!bat_targetdir!\CameraTimeOffsets.txt"

	!bat_logexeclog! copy /y "!bat_caldir!\CameraTimeOffsets.txt" "!bat_targetdir!\CameraTimeOffsets.txt"
	
	!bat_logexeclog! copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!\CameraSites.txt"

	!bat_logexeclog! copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!\Cal\CameraSites.txt"


		rem This section copies all the camera files listed in the CameraSites file, ideally 
		rem for ONLY those cameras that are involved in the current coincidence run.  Perhaps
		rem that can be ascertained after unzipping all the files that match the filespec of 
		rem zips, we can examine, for example, the names of all the CAL files in the directory.
	
	!bat_echolog! call "!bat_exedir!\CopyCamerasFromSitesFile.bat" "!bat_caldir!" "!bat_targetdir!"
	              call "!bat_exedir!\CopyCamerasFromSitesFile.bat" "!bat_caldir!" "!bat_targetdir!"
	
!bat_poplog! [return !bat_batchfile!:COPYPARAMFILES] []
!bat_log!
!bat_return!












:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.  Usage: %~nx0 "^<bat_coincidencedir^>" "^<bat_caldir^>"
	echo.
	echo.  
	echo.  =============================================================
	echo.  ====            COPYPARAMFILES                           ====
	echo.  
	echo.  Copy the cal files from a staged location to the coincidence directory
	echo.  
	echo.  This routine needs to be improved:
	echo.   1] Create a SortDetect_CameraList.txt file
	echo.   2] Create a CalFileList.log file
	echo.   3] If there are any CALSTARS*.txt files
	echo.      3.1] Run FTP_CalStarsReconstitution.exe 100 "!bat_coincidencedir!"
	echo.      3.2] For each CalFileList.log entry that doesn't exist in the bat_coincidencedir
	echo.           scan for it in a previous directory and then copy it to the bat_coincidencedir.
	echo.           If it still isn't found, either scan for it in the CAMS\Cal directory, or
	echo.           simply add it to a CalFileList_missing.log file and let the user know about it.
	echo.      3.3] Run FTP_MeteorCal_AutoUpdate.exe 50 1.6 "!bat_coincidencedir!" "!bat_coincidencedir!"
	echo.   2] 
	echo.  =============================================================
	echo.  
	echo.  
	echo.   Example:
	echo.         call "%~0" "2011_12_14"
	echo.
exit /b -99

	
:ABORT
	!bat_echolog! '    ABORTING
	!bat_echolog! '    bat_returncode=!bat_returncode!
	pause
exit /b !bat_returncode!

:DONE
	!bat_poplog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! [%date% %time%] [!bat_batchfile!:DONE]  Done with %0 %*
	!bat_log!
exit /b !bat_returncode!
