  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

goto :SETUP

		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!
	!bat_logexeclog! call "!bat_exedir!\ReadConfig.bat"
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	if /i "%~2" neq "" (
		!bat_log! We're creating the cal file list in a different area, probably for Coincidence...
		
		!bat_logexeclog! set bat_capturedfilesdir=%~2
		!bat_logexeclog! set bat_caldir=%~3

		!bat_logexeclog! set bat_GCFC_tempfile=!bat_detectdir!\SortDetect_CameraList.txt
	) else (
		set bat_GCFC_tempfile=!bat_detectdir!\SortDetect_CameraList.txt
		set bat_caldir=!bat_startlocation!\Cal
	)

	!bat_logexeclog! set bat_detectfile_temp=%~1
	!bat_logexeclog! set bat_detectfile_filename=%~nx1
	!bat_logexeclog! set bat_detectfile_name=%~n1
	                 set bat_detectfile_dir=%~dp1::
	                 set bat_detectfile_dir=!bat_detectfile_dir:\::=!
	!bat_logexeclog! set bat_detectfile_dir=!bat_detectfile_dir:::=!

	set bat_cameralist_file=!bat_detectfile_dir!\SortDetect_CameraList.txt


goto :MAIN %*



:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] [%*]


	if exist "!bat_cameralist_file!" (
		!bat_log! Already Exists [!bat_cameralist_file!].  Ending !bat_batchfile!...
	) 
	
	(
		!bat_CALL! "!bat_exedir!\CreateCameraListFileFromDetectFile.bat" "!bat_detectfile_temp!"
	)
	

	call :DISPLAYCAMERALIST
	
	set bat_returncode=0
	call :READFILE "!bat_temp_detectfile!"

	if /i "!bat_detectfile_dir!" neq "" (
		if exist "!bat_detectfile_dir!\junk.txt" (
			!bat_logexeclog! del /q "!bat_detectfile_dir!\junk.txt"
		)
	)

goto :DONE





	rem Loop to read the detect file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:READFILE
!bat_pushlog! [CALL !bat_batchfile!:READFILE] "!bat_detectfile_temp!" [%*]
	set bat_retval=success

	if not exist "!bat_detectfile_temp!" (
		!bat_echolog! '    ERROR 1 - Detect file "%~1" not found...
	)
	
	if not exist "!bat_detectfile_temp!" (
		!bat_echolog! '    [:READFILE] detect file "!bat_detectfile_temp!" does not exist
		!bat_echolog! '  ERROR 2 - cannot continue without an FTPdetectinfo file.
		!bat_echolog!
		!bat_echolog! '  The files have already been moved... you will need to move 
		!bat_echolog! '  them back and start over after resolving the problems.
		!bat_echolog!
		!bat_echolog! '  [:READFILE] ERROR - "!bat_readfile!" does not exist
		set bat_retval=failed
		goto :READFILE_END
	)
	
	
	set bat_calfilename=
	set bat_calfilename_prev=
	if exist "!bat_detectfile_dir!\CalFileList.log" (
		if defined bat_detectfile_dir (
			!bat_logexeclog! del /q "!bat_detectfile_dir!\CalFileList.log"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:READFILE] Dangerous command: del "!bat_detectfile_dir!\CalFileList.log"
		)
	)
	
	set bat_cameralist=
	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	!bat_echolog!
	!bat_echolog! This next step could take a long time if the meteor count is
	!bat_echolog! greater than 1,000.  Over that number, it gets exponentially
	!bat_echolog! longer to process. 



	set bat_temp=

	if /i "!bat_detectfile_dir!" neq "" (
		if exist "!bat_detectfile_dir!\junk.txt" (
			!bat_logexeclog! del /q "!bat_detectfile_dir!\junk.txt"
		)
	)
	
	!bat_log! find /i ".txt" "!bat_detectfile_temp!"}"!bat_detectfile_dir!\junk.txt"
	          find /i ".txt" "!bat_detectfile_temp!">"!bat_detectfile_dir!\junk.txt"
	
	!bat_log!     for /f "usebackq tokens=1-3 delims=:" ..a in ^(`find /c "CAL" "!bat_detectfile_dir!\junk.txt"`^) do ^(
	              for /f "usebackq tokens=1-3 delims=:" %%a in  (`find /c "CAL" "!bat_detectfile_dir!\junk.txt"`) do (
		set bat_temp=%%c
	)


	!bat_echolog!
	!bat_echolog! There are !bat_temp! entries in the detect file, please wait... 
	!bat_echolog!

	set bat_temp=
	
	!bat_pushecho! [!time!] !bat_batchfile!:READFILE

	set /a bat_camerainstance=0
	!bat_pushlog!  for /f "usebackq tokens=*" ..x in ^(`type "!bat_cameralist_file!"`^) do ^(
	for                /f "usebackq tokens=*" %%x in  (`type "!bat_cameralist_file!"`) do (
			set /a bat_linecount=0
			rem !bat_pushlog!  for /f "usebackq tokens=* skip=2" ..a in ^(`find /i "cal%%x_" "!bat_detectfile_dir!\junk.txt"`^) do ^(
			for                    /f "usebackq tokens=* skip=2" %%a in  (`find /i "cal%%x_" "!bat_detectfile_dir!\junk.txt"`) do (
				set bat_temp=%%a
				set /a bat_linecount+=1
				set bat_calfilename=%%a
				set bat_camera_temp=!bat_temp:~3,3!
				
				if !bat_linecount! equ 1 (
					set /a bat_camerainstance+=1
					!bat_log! '  !bat_camerainstance!. ADDING: "!bat_calfilename!" TO: "!bat_detectfile_dir!\CalFileList.log"

					set bat_cameralist2=0!bat_camera_temp!

					if !bat_camerainstance! equ 1 (
						echo !bat_calfilename!>"!bat_detectfile_dir!\CalFileList.log"
					) else (
						echo !bat_calfilename!>>"!bat_detectfile_dir!\CalFileList.log"
					)
				)
			)
				!echolog! !bat_calfilename!
			rem !bat_poplog! ^)
	)
	!bat_popecho! [!time!]
	!bat_echolog!


	if !bat_linecount! equ 0 (
		!bat_log!
		!bat_log! '  !bat_batchfile!:READFILEERROR - Failed to process the detect file: !bat_detectfile_temp!
		!bat_log! '  Put them back and start over after resolving the problems.
		!bat_log!
		!bat_log! '  ABORTING
		!bat_log!
		!bat_log! '  [This program could do that in a future update]
		!bat_log! '  [:READFILE] ERROR - ABORTING - Failed to process "!bat_detectfile_temp!"
		set bat_retval=failed
	) else (
		set bat_retval=success
	)

:READFILE_END
!bat_poplog! [RETURN !bat_batchfile!:READFILE] [!bat_retval!, output file=="!bat_detectfile_dir!\CalFileList.log"]
!bat_log!
!bat_return!










	rem Check "CalFileList.log" to see if %~1 already exists in the list
	rem Returns: bat_calfilelist_found=true if found, otherwise, it is undefined
:CHECK_CALFILELIST [in]  "!bat_calfilename!"
               rem [out] bat_calfilelist_found
rem echo [CALL !bat_batchfile!:CHECK_CALFILELIST] [%*]
	set bat_calfilelist_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_detectfile_dir!\CalFileList.log"`) do (
		if /i "%~1"  equ "%%x" (
			set bat_calfilelist_found=true
		)
	)
:CHECK_CALFILELIST_END
rem echo [RETURN !bat_batchfile!:CHECK_CALFILELIST] [%~1, bat_calfilelist_found=!bat_calfilelist_found!]
!bat_return!








	rem Displays the list of cameras.  Depends on GCFC.log file
	rem already being populated with the sorted list of cameras.
:DISPLAYCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:DISPLAYCAMERALIST] %*

		rem Display the list of cameras...
	!bat_log! List of unique cameras in the detect file...
	set bat_camera_list=
	set bat_camera_first=
	set bat_camera_last=
	for /f "usebackq tokens=*" %%a in ("!bat_cameralist_file!") do (
		!bat_log! %%a
		if /i "%%a" neq "" (
			if not defined bat_camera_list (
				set bat_camera_list=0%%a
				set bat_camera_first=%%a
			) else (
				set bat_camera_list=!bat_camera_list!0%%a
				set bat_camera_last=%%a
			)
		)
	)
	
	if !bat_CAPTURE.number.of.cameras GTR 4 (
		set bat_camera_list=0!bat_camera_first!0!bat_camera_last!
	)

:DISPLAYCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAYCAMERALIST] [!bat_camera_list!]
!bat_log!
!bat_return!













:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_log! call "!bat_exedir!\ReadParams.bat"
			  CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<bat_detectfile^>"
	echo.
	echo.Creates the CalFileList.log file, which is a text file containing
	echo.a sorted list of unique cal file names found in the specified 
	echo.detect file.
	echo.
	echo.If running it for Coincidence processing, you might want to run it like
	echo.this:
	echo.    %~nx0 "^<detect file^>" "^<captured files dir^>" "^<cal file dir^>"
	echo.
	echo.Example:
	echo.    %~nx0 "c:\cam213\CAMS\Temp\Coincidence\2014_11_30" "c:\cam213\CAMS\Temp\Coincidence\2014_11_30" "c:\cam213\CAMS\Temp\Coincidence\2014_11_30"
	echo.
	echo.The outcome results in:
	echo.    SortDetect_CameraList.txt file
	echo.    CalFileList.log
	echo.
exit /b -99



:DONE
!bat_poplog! :DONE with %~f0 %*
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
rem dir "!bat_detectfile_dir!\CalFileList.log"
rem type "!bat_detectfile_dir!\CalFileList.log"

	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
		SET bat_camera_list=%bat_cameralist2%
	) ELSE ( echo.%bat_retval%)
exit /b 0