
  @echo off
setlocal enableextensions enabledelayedexpansion



	call "%~dp0AutoCams.setup.bat" "%~f0"
	call "%~dp0indent_setup.bat"
	set bat_pushstring=

	call "!bat_exedir!\ReadParams.bat"


:SETUP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	TITLE %~0 %*
	
	!bat_echolog! ========================================================================
	!bat_echolog! %~0 %*
	!bat_echolog!


rem Delete_During_Capture.bat
rem %~1 is the bat_precaptureddir
rem %~2 is the bat_CAPTURE.delete.during.capture filespec
:MAIN
	echo.[%date% %time%] %~0 %*

	if /i "%~1" equ "" goto :DONE
	if /i "%~2" equ "" goto :DONE

	call :PRECAPTURE %*
	

	echo. [%date% %time%] Waiting 60 seconds.
	!bat_WAIT! 60
	
	call :GETCAPTUREDIR %*

	!bat_WAIT! 10
	
	if /i "!bat_captureddir!" equ "!bat_precaptureddir!" (
		echo................. NO NEW CAPTURE DIR ..............................
		goto :MAIN_END
	)

:MAIN_LOOP

	Rem  Interesting thing about his loop is that it can delete files that capture isn't done with yet.
	rem  Therefore, I collect the list of dummy FF files, then wait 30 seconds for the list to catch up with 
	rem  Then I iterate through the collection of filenames and delete them individually.  
	dir "!bat_captureddir!\!bat_CAPTURE.delete.during.capture!" /b>"!bat_captureddir!\delete.during.capture.txt"
	
	echo.[%date% %time%] Waiting 30 seconds...
	!bat_WAIT! 180
	
	echo.for /f "usebackq tokens=*" ..a in ^(`type "!bat_captureddir!\delete.during.capture.txt"`^) do ^(
	     for /f "usebackq tokens=*" %%a in  (`type "!bat_captureddir!\delete.during.capture.txt"`) do (
	    echo.[%date% %time%] del /q /f "!bat_captureddir!\%%a"
		     del /q /f "!bat_captureddir!\%%a"
	
	)
	
	rem echo del /q /f "!bat_captureddir!\!bat_CAPTURE.delete.during.capture!"
	rem      del /q /f "!bat_captureddir!\!bat_CAPTURE.delete.during.capture!"

	echo.[%date% %time%] Waiting 60 seconds... 
!bat_WAIT! 180
	if not exist "!bat_captureddir!\!bat_CAPTURE.delete.during.capture!" (goto :MAIN_END)
	goto :MAIN_LOOP
:MAIN_END





goto :DONE




:PRECAPTURE
!bat_pushecho! [CALL !bat_batchfile!:PRECAPTURE] %*
	rem [in]	
	rem [out]	bat_precaptureddir
	rem [out]	bat_precaptureddirarch

		rem SIMULATION - Only do this if the [CAPTURE] simulation is set - 
		rem Essentially, clean up the directories to the pre-capture state. 
	if /i "!bat_SIMULATION.enabled!" equ "true" (
		!bat_pushecho! Simulating Capture and Detect by removing the test dirs...
			if defined bat_SIMULATION.CapturedFilesDir (
				!bat_logexec! del /q "!bat_SIMULATION.CapturedFilesDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.CapturedFilesDir!"
				!bat_logexec! del /q "!bat_SIMULATION.ArchivedFilesDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.ArchivedFilesDir!"
				!bat_logexec! del /q "!bat_SIMULATION.SubmittedDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.SubmittedDir!"
				!bat_logexec! del /q "!bat_SIMULATION.SubmittedDir!\!bat_captureddir!_*.zip"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:PRECAPTURE] Dangerous command: del /q "!bat_SIMULATION.CapturedFilesDir!"
			)

			if defined bat_SIMULATION.SubmissionFilesDir  (
				!bat_logexec! del /q /s "!bat_SIMULATION.SubmissionFilesDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.SubmissionFilesDir!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:PRECAPTURE] Dangerous command: del /q /s "!bat_SIMULATION.SubmissionFilesDir!"
				!bat_pause!
				exit /b -98
			)

		!bat_popecho!
rem		set /p bat_choice=Check the ArchivedFiles and CapturedFiles dirs... 
	)& rem SIMULATION

	!bat_log! Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	!bat_log! ordered ascending by date. The last one will be the one BEFORE the next one
	!bat_log! created by the FTP_CaptureXxx executable (for comparison later).

	!bat_logexeclog! set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	!bat_logexeclog! set bat_precaptureddir=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_precaptureddir=!bat_targetsearchspec!\%%~a
				)
			)
		)
	)
		!bat_logexeclog! set bat_precaptureddir
	!bat_poplog!

	if not defined bat_precaptureddir (set bat_precaptureddir= )

	!bat_log! Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	!bat_log! ordered ascending by date. The last one will be the one BEFORE the next one
	!bat_log! created by the FTP_CaptureXxxDetect... executable (for comparison later).

	!bat_logexeclog! set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	!bat_logexeclog! set bat_precaptureddirarch=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_precaptureddirarch=!bat_targetsearchspec!\%%~a
				)
			)
		)
	)
		!bat_logexeclog! set bat_precaptureddirarch
	!bat_poplog!

	if not defined bat_precaptureddirarch (set bat_precaptureddirarch= )
		

:PRECAPTURE_END
!bat_popecho! [RETURN !bat_batchfile!:PRECAPTURE] [bat_precaptureddir="!bat_precaptureddir!", 
!bat_echolog! '                                            bat_precaptureddirarch="!bat_precaptureddirarch!"] 
!bat_echolog! '                                            %*
!bat_echolog!
!bat_return!





:GETCAPTUREDIR [in] %* 
!bat_pushecho! [CALL !bat_batchfile!:GETCAPTUREDIR] %*
	rem [out]	bat_retval
	rem [out]	bat_captureddir
	rem [out]	bat_captureddate
	rem [out]	bat_capturedbasedir


	!bat_echo!
	!bat_echo! Attempting to determine the directory name that 
	!bat_echo! !bat_captureexesrc! created.  
	!bat_echo!
	!bat_echo! It looks at all the subdirs of the CaptureFiles dir in date order.  The last 
	!bat_echo! one in the list should be the most recent FTP_CaptureAndDetect directory.
	!bat_echo!

	rem Careful, there is a chance that it didn't create a directory at all and 
	rem you'd be choosing the wrong dir. Compare with bat_precaptureddir to protect 
	rem against that. 

	set bat_retval=failed

	set bat_targetsearchdir=
	set bat_captureddir=
	set bat_captureddirname=
	set bat_capturedbasedir=
	set bat_captureddate=
	set bat_capturedtime=

	!bat_logexeclog! set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem Note: This loop sets these variable each time through the loop.
					rem       When the loop is done, the last iteration will make the
					rem       needed settings.

					rem Example: bat_captureddir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					set bat_captureddir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_captureddirname=2012_01_18_01_00_13
					set bat_captureddirname=%%~nxa

					rem Example: bat_targetsearchdir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					set bat_targetsearchdir=!bat_targetsearchspec!\%%~a

					rem example: bat_capturedbasedir=C:\CAMS\CapturedFiles
					set bat_capturedbasedir=%%~dpa::
					set bat_capturedbasedir=!bat_capturedbasedir:\::=!
					set bat_capturedbasedir=!bat_capturedbasedir:::=!
				)
			)
		)
	)
		rem Log the settings that were made in the last iteration of the loop.
		!bat_logexeclog! set bat_captured
	!bat_poplog! ^) // for...
	!bat_log!

	!bat_log! if not defined bat_captureddir ^(
	if           not defined bat_captureddir (
		!bat_pushecho!
			!bat_echolog! '    ERROR - There are no CapturedFiles directories. Interpreting that as a
			!bat_echolog! '    capture failure or manual abort. 
		!bat_popecho! ^) // goto GETCAPTUREDIR_END
		goto :GETCAPTUREDIR_END
	) else (
		!bat_pushlog! ^) else ^(
			!bat_echolog!  FOUND - bat_captureddir is defined [!bat_captureddir!]
		!bat_poplog! ^)
	)& rem else...


	!bat_echolog!
	!bat_log! if /i "!bat_captureddir!" equ "!bat_precaptureddir!" ^( 
	if           /i "!bat_captureddir!" equ "!bat_precaptureddir!" (
		!bat_push!
			!bat_echolog!
			!bat_echolog! ERROR - Capture did not produce a new directory. Interpreting that as a
			!bat_echolog! '       capture failure. 

			set bat_targetsearchdir=
			set bat_captureddir=
			set bat_captureddirname=
			set bat_capturedbasedir=
			set bat_captureddate=
			set bat_capturedtime=
		!bat_popecho! ^) // goto GETCAPTURDIR_END
		goto :GETCAPTUREDIR_END
	) else (
		!bat_pushlog! ^) else ^( 
			!bat_pushecho! Capture was a success and it produced a new CapturedFiles directory:
				!bat_echolog! "!bat_captureddir!"
				!bat_logexeclog! set bat_retval=success
				!bat_logexeclog! set bat_retval=!bat_captureddir!
				!bat_logexeclog! set bat_capturedfilesdir=!bat_captureddir!

				rem Example: bat_captureddate=2012_01_18
				!bat_logexeclog! set bat_captureddate=!bat_captureddirname:~0,10!
				!bat_logexeclog! set bat_capturedtime=!bat_captureddirname:~11,8!
				!bat_logexeclog! set bat_captureddatetime=!bat_captureddirname:~0,19!

				rem Change the settings so that log files belong to the captureddate from now on...
				!bat_pushlog! call "!bat_exedir!\RedirectLogs.bat" "!bat_logdir!" "!bat_exedir!\Logs\!bat_captureddatetime!"
						      call "!bat_exedir!\RedirectLogs.bat" "!bat_logdir!" "!bat_exedir!\Logs\!bat_captureddatetime!"
				!bat_poplog!
			!bat_popecho!

			!bat_logexeclog! set bat_cap
			!bat_logexeclog! set bat_targetsearchdir
		
		!bat_poplog! ^) // 
	)& rem else...
	
:GETCAPTUREDIR_END
!bat_popecho! [RETURN !bat_batchfile!:GETCAPTUREDIR] [bat_retval=!bat_retval!, 
!bat_echolog! '                                             bat_captureddir=!bat_captureddir!, 
!bat_echolog! '                                             bat_captureddate=!bat_captureddate!
!bat_echolog! '                                             bat_capturedtime=!bat_capturedtime!]
!bat_echolog!
!bat_return!



:HELP
goto :DONE



:DONE

