  @echo off
setlocal enabledelayedexpansion enableextensions

REM THIS SHOULD NOT BE CALLED USING !BAT_LOGEXEC!

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	echo.
	goto :SETUP %*

:CHECKHELP_END

	
:SETUP

	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!
	
		rem Get the SaveConfig.bat bat_captureddate, bat_capturedtime
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
	!bat_logexeclog! set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	!bat_logexeclog! set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! `     !bat_batchfile!:SETUP - ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	if /i "%~2" equ "" (
		!bat_echolog! `    !bat_batchfile!:SETUP - ERROR - Missing command line argument:
		!bat_echolog! `        "%~f0" %*
		exit /b -95
	)
	
	!bat_logexeclog! set bat_can_rename=true
	
	!bat_logexeclog! set bat_caldir=!bat_startlocation!\Cal
	
	!bat_logexeclog! set bat_retvar=%~1
	!bat_logexeclog! set bat_archivedfilesdir=%~2
	
	if /i "!bat_archivedfilesdir:~0,4!" equ "bat_" (
		!bat_log! converting the old way.aaaaa [!%~2!]

		!bat_logexeclog! set bat_archivedfilesdir=!%~2!
	)
	
	
	if /i "%~3" neq "" (
		!bat_log! `    Using command line argument for bat_capturedfilesdir [!bat_capturedfilesdir!] instead of autocams.bat.ini as:
		!bat_logexeclog! set bat_capturedfilesdir=%~3
	)

	if /i "!bat_capturedfilesdir!" equ "" (
		echo.!bat_archivedfilesdir!|find /i "\ArchivedFiles"
		if !errorlevel! equ 0 (
			!bat_log! `    Fabricating the bat_capturedfilesdir from the specified ArchivedFiles dir...
			!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir:ArchivedFiles=CapturedFiles!
		)
		
		echo.!bat_archivedfilesdir!|find /i "\ConfirmedFiles"
		if !errorlevel! equ 0 (
			!bat_log! `    Fabricating the bat_capturedfilesdir from the specified ConfirmedFiles dir...
			!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir:ConfirmedFiles=CapturedFiles!
		)
	)
	
	if not exist "!bat_capturedfilesdir!" (
		!bat_log! `    Fabricating the bat_capturedfilesdir by assuming that the capturedfiles dir is the same as the archivedfiles dir
		!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir!
		!bat_logexeclog! set bat_can_rename=
	)

	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	if not exist "!bat_GCFC_tempfile!" (
		!bat_log! a GCFC.log [camera list file] file doesn't exist, so building one...
		!bat_logexeclog! !bat_CALL! "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
	)

	
		rem Fetch: bat_camera, bat_camera_list, bat_camera_first, bat_camera_last
	call :DISPLAYCAMERALIST
	
	set bat_returncode=0

goto :GETDETECTFILE %*




:GETDETECTFILE [in] "bat_detectfile" "!bat_archivedfilesdir!"
!bat_pushlog! [GOTO !bat_batchfile!:GETDETECTFILE] %*

	if "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		!bat_echolog! `    !bat_batchfile!:GETDETECTFILE - ERROR 1 - No dir specified in argument 2
		goto :GETDETECTFILE_END
	)

		rem Results in bat_temp having a dirname, such as: "2012_08_11_03_42_01"
	set bat_temp=

%bat_COMMENT_BEGIN%
	call :PARSETEMP "!bat_archivedfilesdir!"
	
	if /i "!bat_temp!" equ "" (
		set bat_returncode=6
		!bat_echolog! `    !bat_batchfile!:GETDETECTFILE - ERROR 6 - value of argument 2 is empty
		goto :GETDETECTFILE_END
		
	)

	rem The bat_captureddate can be appropriately derrived this way and
	rem it will be used later in this routine.
	if /i "!bat_temp!" neq "" (
		set bat_captureddate=!bat_temp:~0,10!
	) else (
		set bat_returncode=2
		!bat_echolog! `    !bat_batchfile!:GETDETECTFILE - ERROR 2 - Argument 2 [!bat_archivedfilesdir!] is not defined in the calling script.
		goto :GETDETECTFILE_END
	)



		rem The bat_capturedtime can be appropriately derrived this way and
		rem it will be used later in this routine.
	if /i "!bat_temp!" neq "" (
		set bat_capturedtime=!bat_temp:~11,8!
	) else (
		set bat_returncode=3
		!bat_echolog! `    !bat_batchfile!:GETDETECTFILE - ERROR 2 - Argument 2 [!bat_archivedfilesdir!] is not defined in the calling script.
		goto :GETDETECTFILE_END
	)

%bat_COMMENT_END%

	set %~1=
	set bat_detectfile_found=
	set bat_detectfile1=
	set bat_detectfile2=
	set bat_detectfile3=
	set bat_detectfile4=
	set bat_detect_rename=


	!bat_pushlog! if exist "!bat_archivedfilesdir!\FTPdetectinfo*.txt" ^(
		if           exist "!bat_archivedfilesdir!\FTPdetectinfo*.txt"  (
			!bat_log!
			!bat_log! `Note: The following FOR loop is sorted in ascending date order so that
			!bat_log! `      the last item in the list is the most recently created detect file.
			!bat_log!
			!bat_pushlog! for /f "usebackq tokens=*"   a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo*.txt" /b /od /a-d`^) do ^(
				for           /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo*.txt" /b /od /a-d`) do (
					!bat_log! %%~a
					
					!bat_logexeclog! set bat_detectfile_found=%%~a

					!bat_logexeclog! set bat_detectfile3=%%~na
					!bat_logexeclog! set bat_detectfile2=%%~nxa
					!bat_logexeclog! set bat_detectfile1=!bat_archivedfilesdir!\!bat_detectfile2!
					!bat_logexeclog! set bat_detectfile4=!bat_archivedfilesdir!\!bat_detectfile2!
					!bat_logexeclog! set %~1=!bat_detectfile4!
				)
			!bat_poplog! ^)

		)

		if not defined bat_detectfile_found (
			set bat_returncode=4
			!bat_echolog! `   !bat_batchfile!:GETDETECTFILE - WARNING 4 - Can't find detect file in [bat_archivedfilesdir="!bat_archivedfilesdir!"]
			!bat_echolog! `    NO DETECT FILES FOUND IN: "!bat_archivedfilesdir!"
			!bat_echolog!

			!bat_echolog!
			!bat_echolog! Now making sure that the bat_archivedfilesdir value has "ArchivedFiles" in it somewhere...
			!bat_echolog! Question though: What is supposed to happen when it's a detect file in the coincidence dir?
			!bat_echolog!

			!bat_echolog! "!bat_archivedfilesdir!" ^| FINDSTR /L /i /c:"ArchivedFiles" /c:"ConfirmedFiles"}nul: 2}^@1
			         echo."!bat_archivedfilesdir!"  | FINDSTR /L /i /c:"ArchivedFiles" /c:"ConfirmedFiles">nul: 2>&1
			if /i "!errorlevel!" equ "0" (
				!bat_echolog!
				!bat_echolog! `    !bat_batchfile!:GETDETECTFILE ERROR
				!bat_echolog!
				!bat_echolog! `    There may be a possibility that the CaptureAndDetect didn't finish all the way.
				!bat_echolog! `    Another possibility is that the file is misnamed somehow.  Check the 
				!bat_echolog! `    "!bat_archivedfilesdir!" directory.  If the directory isn't found or there are
				!bat_echolog! `    no FF*.bin files, or there isn't a FTPdetectinfo*.txt file there, you may
				!bat_echolog! `    need to run option 44 to rebuild the detect from the capture session again.
				!bat_echolog! `    
			)
			
			
			goto :GETDETECTFILE_END
		)
		
	)
	!bat_poplog! ^)



		rem Going into this section, the bat_detectfile1 variable should be read-only as the source
		rem detect file in case it needs to be renamed.
	if defined bat_detectfile_found (
		!bat_pushlog!
			!bat_log! ---------------------------------------------------------
			!bat_log! This section is about determining whether to rename the detect file
			!bat_log!
			!bat_log! Note: The following loop parses the detect file name to see what the
			!bat_log! `       format of the file name is.  If it's an old format, it will be
			!bat_log! `       converted to the new format. This is accomplished by parsing the file
			!bat_log! `       by the "_" and "." delimiters.  If the "txt" is the 2nd token, then
			!bat_log! `       it's in "FTPdetectinfo.txt" format and its missing the camera, date, and time.  
			!bat_log! `       If "txt" is the 6th token, then it's in the "FTPdetectinfo_CCCC_YYYY_MM_DD.txt" 
			!bat_log! `       or the "FTPdetectinfo_0CCC0CCC_YYYY_MM_DD.txt" format and it's missing the 
			!bat_log! `       time.  Otherwise, no conversion is necessary.  
			!bat_log!
			!bat_log! `     One issue we may find with this is if the file name cointains "Coinc".  In that
			!bat_log! `     we need to not do a conversion. However, in that case, "txt" will be the
			!bat_log! `     3rd token.
			!bat_log!

			echo.!bat_detectfile4!|findstr /L /i /c:"\EmailFiles" /c:"_scanned" /c:"_confirmed"
			if !errorlevel! equ 0 (
				!bat_logexeclog! set bat_can_rename=
				!bat_log! !bat_detectfile4!][findstr /L /i /c:"\EmailFiles" /c:"_scanned" /c:"_confirmed"
				goto :CONTINUE
			)

				rem Parse the detect file name without the path in to 12 separate parts so
				rem that we can check or where the "txt" element is placed

			for /f "usebackq tokens=1-12 delims=_." %%a in ('!bat_detectfile2!') do (

				!bat_log! a=%%a, b=%%b, c=%%c, d=%%d, e=%%e, f=%%f, g=%%g, h=%%h, i=%%i, j=%%j, k=%%k, l=%%l

				if /i "%%b" equ "00" (
					!bat_logexeclog! set bat_detect_rename=true
				)

				if /i "%%c" equ "txt" (
					set bat_temp=%%b
					if "!bat_temp:~0,2!" equ "000" (
						!bat_log! Not renaming "%%a_%%b.%%c"
						goto :CONTINUE
					)
				)

				if /i "%%i" neq "txt" (
					set bat_detect_rename=true
				)
			)
		!bat_pop!

 :CONTINUE
    !bat_log! [!bat_batchfile!:CONTINUE] bat_detect_rename="!bat_detect_rename!", bat_can_rename="!bat_can_rename!"
    
				if defined bat_detect_rename (
					!bat_logexeclog! set bat_detectfile3=FTPdetectinfo_!bat_camera_list!_!bat_captureddate!_!bat_capturedtime!
					!bat_logexeclog! set bat_detectfile2=!bat_detectfile3!.txt
					!bat_logexeclog! set bat_detectfile4=!bat_archivedfilesdir!\!bat_detectfile2!
					!bat_logexeclog! set %~1=!bat_detectfile4!
					rem bat_detectfile1 is the source detect file so don't assign it a new value

					call :RENAME_DETECT

				) else (
					!bat_log! `  It's in this format: FTPdetectinfo_CCCC_YYYY_MM_DD_hh_mm_ss.txt of FTPdetectinfo_0CCC0CCC_YYYY_MM_DD_hh_mm_ss.txt
					!bat_log! `    No conversion necessary.
					!bat_log!
				)
	) else (
		set bat_returncode=5
		goto :GETDETECTFILE_END
	)


:GETDETECTFILE_END
	!bat_poplog! Returning value in the [%~1] variable using ENDLOCAL:
	
	!bat_log! `[ENDLOCAL-!bat_batchfile!:GETDETECTFILE] [
	!bat_log! `                   bat_returncode=!bat_returncode!,,
	!bat_log! `                   !bat_retvar!=!%bat_retvar%!,
	!bat_log! `                   bat_camera_list=!bat_camera_list!, 
	!bat_log! `                   bat_camera=!bat_camera!, 
	!bat_log! `                   bat_camera_first=!bat_camera_first!,
	!bat_log! `                   bat_camera_last=!bat_camera_last!,
	!bat_log! `                   file="%~1\GCFC.log"]
	!bat_log!
	!bat_poplog! !bat_batchfile!:GETDETECTFILE - EXIT /B !bat_returncode!
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

	ENDLOCAL & IF "%~1" NEQ "" (
		set bat_returncode=%bat_returncode%
		SET %bat_retvar%=%bat_detectfile4%
		set bat_camera_list=%bat_camera_list%
		set bat_camera=%bat_camera%
		set bat_camera_first=%bat_camera_first%
		set bat_camera_last=%bat_camera_last%
	) ELSE (
		echo.%bat_detectfile4%
	)
EXIT /B !bat_returncode!




:RENAME_DETECT
!bat_pushlog! [CALL !bat_batchfile!:RENAME_DETECT] [bat_can_rename=!bat_can_rename!, bat_detct_rename=!bat_detect_rename!, bat_detectfile4=!bat_detectfile4!]

	!bat_echolog! `  !bat_batchfile!:GETDETECTFILE - Wrong Format: "!bat_detectfile_found!"

	!bat_log! bat_captureddate=!bat_captureddate!
	!bat_log! bat_capturedtime=!bat_capturedtime!
	!bat_log! bat_camera_list=!bat_camera_list!

	if not defined bat_captureddate (!bat_logexeclog! set bat_can_rename=)
	if not defined bat_capturedtime (!bat_logexeclog! set bat_can_rename=)
	if not defined bat_camera_list  (!bat_logexeclog! set bat_can_rename=)
	if /i "!bat_camera_list!" equ "" (!bat_logexeclog! set bat_can_rename=)
	
	if defined bat_detect_rename (
		if defined bat_can_rename (

				!bat_ECHOlog! `   RENAMING to: "!bat_detectfile2!"
				!bat_echolog!
				!bat_ECHOlog! `      move /y "!bat_archivedfilesdir!\!bat_detectfile_found!" "!bat_detectfile4!"
									 move /y "!bat_archivedfilesdir!\!bat_detectfile_found!" "!bat_detectfile4!"
				!bat_echolog!
			)

		) else (
			!bat_echolog! `    !bat_batchfile!:RENAME_DETECT - can't rename because file name is too complex:
			!bat_echolog! `                        !bat_retvar!=!bat_detectfile4!
		)
	)


:RENAME_DETECT_END
!bat_poplog! [RETURN !bat_batchfile!:RENAME_DETECT] [bat_can_rename=!bat_can_rename!, bat_detct_rename=!bat_detect_rename!]
!bat_log!
!bat_return!




:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_return!



	rem Parses the specified path [like "bat_archivedfilesdir"] and extracts
	rem just the directory name of the last directory in the path.  For example:
	rem   C:\CAMS\ArchivedFiles\2012_08_11_03_42_01
	rem results in:
	rem   2012_08_11_03_42_01
	rem 
	rem Note: The value must be assigned by the calling batch file.
:PARSETEMP
!bat_pushlog! [CALL !bat_batchfile!:PARSETEMP] %*
	set bat_temp=%~nx1
!bat_poplog! [RETURN !bat_batchfile!:PARSETEMP] [!bat_temp!]
!bat_log!
!bat_return!



	rem ***********************************************************************
	rem *******                  :DISPLAYCAMERALIST                    ********
	rem********                                                        ********
	rem Displays the list of cameras.  Depends on GCFC.log file
	rem already being populated with the sorted list of cameras.
	rem
	rem also remember that sometimes bat_capturedfilesdir might be
	rem pointing to a coincidence or an emailfiles dir.
	rem 
	rem Results:
	rem 
	rem    bat_camera_list 
	rem    bat_camera 
	rem    bat_camera_first
	rem    bat_camera_last
	rem 
	
:DISPLAYCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:DISPLAYCAMERALIST] %*

		rem Display the list of cameras...
	!bat_log! List of cameras found in the camera list file: "!bat_capturedfilesdir!"

	!bat_CALL! "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
	

:DISPLAYCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAYCAMERALIST] [
!bat_log! `                            bat_camera_list=!bat_camera_list!, 
!bat_log! `                            bat_camera=!bat_camera!, 
!bat_log! `                            bat_camera_first=!bat_camera_first!,
!bat_log! `                            bat_camera_last=!bat_camera_last!,
!bat_log! `                            file="!bat_capturedfilesdir!\GCFC.log"]
!bat_log!
!bat_return!










:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "bat_detectfile" "%%bat_archivedfilesdir%%" ["%%bat_capturedfilesdir%%"]
	echo.
	echo Returns the detect file found in the given directory in the second
	echo argument.  If found, the full path/filename is returned in the 
	echo environment variable passed as the first argument. 
	echo.
	echo Example 1:
	echo    set bat_archivedfilesdir=c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfile"     "bat_archivedfilesdir"
	echo Results: bat_detectfile=
	echo    "c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Example 2:
	echo    set bat_confirmedfilesdir=c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfileconf" "bat_confirmedfilesdir"
	echo Results: bat_detectfile=
	echo    c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Notice how the environment variable names are passed an not their
	echo values.  
	echo.
	echo.The script ends like this, so you can see which variables it sets.
	echo.		ENDLOCAL & IF "%~1" NEQ "" (
	echo.			SET %~1=%bat_detectfile4%
	echo.			set bat_returncode=%bat_returncode%
	echo.			set bat_camera_list=%bat_camera_list%
	echo.		) ELSE (echo.%bat_detectfile4%)
	echo.	EXIT /B !bat_returncode!
	echo.
	echo.
	echo.
exit /b -99



:DONE
