@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
    if "%~3" equ "" goto :HELP

:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	!bat_title! 

	set bat_var_firstfile=%~1
	set bat_var_lastfile=%~2
	
	set bat_sourcedir=%~3
	set bat_sourcedrive=!bat_sourcedir:~0,2!
	if /i "!bat_sourcedrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! Invalid path ["!bat_sourcedir!"]
		set bat_returncode=1
		goto :DONE
	)
	
	set bat_camera_target=???
	if "%~4" neq "" (
		set bat_camera_target=%~4
	) 

	set bat_tempfile_name=!bat_batchfile!.txt
	set bat_tempfile_full=!bat_sourcedir!\!bat_tempfile_name!

goto :MAIN %*




:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0

		call :GETFIRSTFILENAME bat_var_firstfile "!bat_sourcedir!"

		call :GETLASTFILENAME bat_var_lastfile "!bat_sourcedir!"

	)
	
	(
rem		for /f "usebackq tokens=*" %%a in (`type "!bat_tempfile_full!"`) do (
rem			!bat_logexec! set %%a
rem		)
	)


	REM Leave the file there so it doesn't need to be recreated.
	if exist "!bat_tempfile_full!" (
rem		!bat_logexeclog! del /q "!bat_tempfile_full!"
	)

:MAIN_END
!bat_log! [END-!bat_batchfile!:MAIN] [bat_var_firstfile="!bat_var_firstfile!", bat_var_lastfile="!bat_var_lastfile!"]
!bat_log! - goto :DONE
!bat_log!

echo.%~1=%bat_var_firstfile%>"!bat_tempfile_full!"
echo.%~2=%bat_var_lastfile%>>"!bat_tempfile_full!"

!bat_log! goto %~nx0:DONE [!bat_returncode!]
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


( ENDLOCAL & (
	rem echo.SET %~1=%bat_var_firstfile%
	rem echo.SET %~2=%bat_var_lastfile%

	SET %~1=%bat_var_firstfile%
	SET %~2=%bat_var_lastfile%
	set bat_returncode=%bat_returncode%
	)
)

goto :DONE2









	rem *************************************************************
	rem ***** Routine to get first filename sorted REVERSE     ******
	rem *************************************************************
	
:GETFIRSTFILENAME [out var_firstfile] [out var_lastfile] [in path]
!bat_pushlog! [CALL !bat_batchfile!:GETFIRSTFILENAME] %*

	set bat_returncode=0

	
	if defined bat_camera_target (
		set bat_searchspec=FF!bat_camera_target!_*.bin
	) else (
		set bat_searchspec=FF???_*.bin
	)

	!bat_titlewait!
	
	!bat_log! dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /o-n^}"!bat_tempfile_full!"
			  dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /o-n>"!bat_tempfile_full!"

	!bat_title!
	
	              
	set /a bat_temp_filesize=0

	call :GETFILELEN "!bat_tempfile_full!"  "!bat_searchspec!"

	rem returns value in variable "%~1", such as bat_var_firstfile
	call :LOOP "%~1" "!bat_linecount!" "!bat_tempfile_full!"



:GETFIRSTFILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GETFIRSTFILENAME] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        %~1=!%~1!]
!bat_log!
!bat_return!








	rem *************************************************************
	rem ***** Routine to get first filename sorted FORWARD     ******
	rem *************************************************************
	
:GETLASTFILENAME [out var_firstfile] [out var_lastfile] [in path]
!bat_pushlog! [CALL !bat_batchfile!:GETLASTFILENAME] %*

	set bat_returncode=0

	if defined bat_camera_target (
		set bat_searchspec=FF!bat_camera_target!_*.bin
	) else (
		set bat_searchspec=FF???_*.bin
	)


	!bat_titlewait!

		!bat_log! dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /on^}"!bat_tempfile_full!"
		          dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /on>"!bat_tempfile_full!"
	              
	!bat_title!
	
	set /a bat_temp_filesize=0
	              
	call :GETFILELEN "!bat_tempfile_full!" "!bat_searchspec!"

	rem returns value in variable "%~1", such as bat_var_firstfile
	call :LOOP "%~1" "!bat_linecount!" "!bat_tempfile_full!"


:GETLASTFILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GETLASTFILENAME] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        %~1=!%~1!]
!bat_log!
!bat_return!




:GETFILELEN
!bat_pushlog! [CALL :GETFILELEN] [%*]

	!bat_titlewait!

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "%~1"][FIND /c /i ".bin"^) do ^(
	          for /f "usebackq tokens=*" %%a in  (`type "%~1"^|FIND /c /i ".bin"`)  do (
		set /a bat_linecount=%%~a
	)
	
	!bat_title!
	
	!bat_log! Matching entries: bat_linecount="!bat_linecount!"
	
:GETFILELEN_END
!bat_poplog! [RETURN !bat_batchfile!:GETFILELEN] [bat_returncode=!bat_returncode!, bat_linecount=!bat_linecount!]
!bat_log!
!bat_return!




:LOOP
!bat_pushlog! [CALL !bat_batchfile!:LOOP] [%*]
	set bat_returncode=0
	
	!bat_titlewait!

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "%~3"`^) do ^(
	          for /f "usebackq tokens=*" %%a in  (`type "%~3"`)  do (
		set %~1=%%~a
	)

	!bat_title!
	
:LOOP_END
!bat_poplog! [RETURN !bat_batchfile!:LOOP] [bat_returncode=!bat_returncode!, %~1=!%~1!, %~3=!%~3!]
!bat_log!
!bat_return!






:STRIPWHITESPACE
	set %~1=!%~1!
!BAT_RETURN!




:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_logexeclog! call "!bat_exedir!\Readini.bat" "!bat_configfile!" "CAMSMENU" bat_capturedfilesdir /q
	if !bat_logexec_returncode! equ 0 (
		set bat_capturedfilesdir=!RetVal1!
	)

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [!bat_capturedfilesdir!]
!bat_log!
!bat_return!






:HELP
	echo %~0      Batch Script
	echo.
	echo.     Usage %~0 "^<var_firstfile^>"    "^<var_lastfile^>"   "^<target directory path^>" "^<camera^>"
	echo.
	echo.     Example: 
	echo.        %~0 bat_firstfile bat_lastfile "C:\CAMS\CapturedFiles\2011_10_21_01_58_22"
	echo.
	echo.     This script will examine the specified directory and return into the variable names
	echo.     specified on the command line the file names of the first and last FF files in the 
	echo.     dir.
	echo.
	echo.     RETURN CODES:
	echo.        0 = success, %%var_firstfile%%,  %%var_lastfile%%
	echo.        1 = Invalid dir specification. [!bat_sourcedir!]
exit /b -99



:DONE
	!bat_log! goto %~nx0:DONE [!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:DONE2
	exit /b %bat_returncode%
