
   @echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~f0"
	call "%~dp0indent_setup.bat"

	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=
	)

    if not defined bat_LOCALIZE.format.date (
    	call "!bat_exedir!\ReadParams.bat"
    )
 
	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	set bat_returncode=-1

	if /i "%~1" equ "" (
		!bat_echolog!
		!bat_echolog! `    !bat_batchfile!:SETUP - ERROR - No detect file specified. 
		!bat_echolog!
		goto :DONE
	)
	
	!bat_logexeclog! set bat_detectfile=%~1

	call :GETEVENTCOUNT "!bat_detectfile!"

goto :DONE



	rem ***********************************************************************
	rem ***********          :GETEVENTCOUNT                       *************
	rem 
	rem Usage: call :GETEVENTCOUNT "any full detectfile name"
	rem	
	rem Scans the given detect file for a count of ".bin" instances. 
	rem 
	rem Returns:
	rem     ERRORLEVEL   -1 if there is an error
	rem                   # Any number greater than or equal to zero
	rem                     if it's a valid detect file.
	
:GETEVENTCOUNT [in]detectfile [out]bat_returncode
!bat_pushlog! [CALL !bat_batchfile!:GETEVENTCOUNT] [%*]

	set bat_tempfile=%~1

	set bat_returncode=0
	set /a bat_countdashes=0

	if exist "!bat_tempfile!" (

	    !bat_pushlog! for /f "usebackq tokens=1-3 delims=: skip=1" ..X in ^(`find /i /c  ".bin" "!bat_tempfile!"`^) ...
		for               /f "usebackq tokens=1-3 delims=: skip=1" %%X in  (`find /i /c  ".bin" "!bat_tempfile!"` ) do (
			if "%%X" neq "" (

					rem Strip the leading spaces
				for /f %%T in ("%%Z") do (
					!bat_logexeclog! set bat_countdashes=%%T
					!bat_logexeclog! set /a bat_returncode=%%T
				)
			)
		)
		!bat_poplog!

		set bat_countdashes=000000!bat_countdashes!
		set bat_countdashes=!bat_countdashes:~-6!
		!bat_log! Meteor Count = !bat_countdashes!
		title Meteor Count = !bat_countdashes!  "!bat_tempfile!" 
		set bat_returncode=!bat_countdashes!
	) else (
		!bat_log! `  File not found - "!bat_tempfile!"
		set bat_returncode=-1
	)

!bat_poplog! [RETURN !bat_batchfile!:GETEVENTCOUNT] [!bat_returncode!]
!bat_log!
!bat_return!




:HELP
	echo.Usage: call "GetMeteorCount.bat" "fully qualified detect file name"
	echo.
	echo.Scans the specified detect file and counts the number of ".bin" 
	echo.instances by using the FIND /i /c ".bin" "detect file" command.
	echo.
	echo.Returns:
	echo.  ERRORLEVEL        ###   a number zero or higher indicates success
	echo.                          and the number is the count.
	echo.                     -1   Any number less than 0 means error.
	echo.
	echo.Example:
	echo.  call "GetMeteorCount.bat" "C:\CAM213\CAMS\ARCHIVEDFILES\2014_12_25_04_40_39\FTPDETECTINFO_0_2014_12_25_04_40_39.TXT"
	echo.
	
	
exit /b -99


:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

exit /b !bat_returncode!
