@echo off

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
        rem                     -- JD   [in]  - julian days
        rem                     -- YYYY [out] - gregorian year, i.e. 2006
        rem                     -- MM   [out] - gregorian month, i.e. 12 for december
        rem                      -- DD   [out] - gregorian day, i.e. 31
        rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
        rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
        rem :$source http://www.dostips.com
        SETLOCAL ENABLEDELAYEDEXPANSION
        set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
        set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
        set /a J= J+2-12*L,      I= 100*(N-49)+I+L
        set /a YYYY= I,  MM=100+J,  DD=100+K
        set MM=!MM:~-2!
        set DD=!DD:~-2!

	if defined bat_log (
		!bat_pushlog! [%~0:ENDLOCAL  %*] {
		!bat_log! %~0:ENDLOCAL { 
		!bat_log! .               [SET %~2=%YYYY%]
		!bat_log! .               [SET %~3=%MM%]
		!bat_log! .               [SET %~4=%DD%]
		!bat_poplog! }
	)

        ( ENDLOCAL & (
            IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
            IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
            IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
        ))
EXIT /b 0
