  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


:CHECKHELP
		echo.%*|find /i "/?">nul:
		if %errorlevel% equ 0 goto :HELP
		echo.%*|find /i "/h">nul:
		if %errorlevel% equ 0 goto :HELP
		echo.%*|find /i "/help">nul:
		if %errorlevel% equ 0 goto :HELP
goto :SETUP %*


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	
	!bat_logexeclog! set bat_submissiondir=%~1
	set bat_submissionbasedir=%~dp1::
	set bat_submissionbasedir=!bat_submissionbasedir:\::=!
	!bat_logexeclog! set bat_submissionbasedir=!bat_submissionbasedir:::=!
	
	if /i "%~2" neq "" (
		!bat_logexeclog! set bat_delete_bin_files=%~2
	) else (
		!bat_logexeclog! set bat_delete_bin_files=
	)
	
	!bat_logexeclog! set bat_targetzipfilename=%~nx1.zip
	!bat_logexeclog! set bat_targetfullzipfile=!bat_submissionbasedir!\!bat_targetzipfilename!

goto :MAIN %*
	

:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*
	set bat_returncode=1
	
	rem !bat_logexeclog! set bat_

		rem The errorlevel will be "0" if there are any directories under
		rem CapturedFiles. 
	!bat_pushecho! Listing subdirectories of the bat_submissiondir:
		!bat_logexec! dir "!bat_submissiondir!" /s/b /ad
	!bat_popecho!
	
	rem Display the drive space and free space BEFORE zipping
	!bat_logexec! call "!bat_exedir!\listdrives.bat"

	!bat_echolog!


	if exist "!bat_submissiondir!" (
		rem There may be a problem with using bat_camera because there may be multiple submissions for different
		rem cameras for the date. It should probably be done in a loop instead.
		
		!bat_logexeclog! set bat_camera_save=!bat_camera!
		
		!bat_log! Iterate through all the camera directories under the bat_submissiondir, which would have the
		!bat_log! form: C:\CAMS\SubmissionFiles\2014_08_08_214_03_50_36
		!bat_log! but it may have multiple cameras under it that don't match the current bat_camera value
		set bat_camera_loop_abort=false
		!bat_pushlog! for /f "usebackq tokens=*" %%c in ^(`dir "!bat_submissiondir!" /b /ad /on`^) do ^(
		              for /f "usebackq tokens=*" %%c in  (`dir "!bat_submissiondir!" /b /ad /on`) do (

			if /i "!bat_camera_loop_abort!" neq "true" (
				!bat_logexeclog! set bat_camera=%%~nxc
				!bat_logexeclog! set bat_sourcecaptureddir=!bat_submissiondir!\!bat_camera!\CapturedFiles

				!bat_echolog!
				!bat_logexec! dir "!bat_sourcecaptureddir!" /s/b /ad /on
				!bat_echolog!

				if not defined bat_delete_bin_files (
							  set /p bat_choice="Do you want to permanently delete all the *.bin files from [!bat_sourcecaptureddir!]? [Y/N] "
					!bat_log! set /p bat_choice="Do you want to permanently delete all the *.bin files from [!bat_sourcecaptureddir!]? [Y/N] "
					!bat_echolog!
				)

				if /i "!bat_choice!" equ "q" (
					!bat_logexeclog! set bat_camera_loop_abort=true
					!bat_logexeclog! set bat_returncode=99
					goto :MAIN_END
				)

				if /i "!bat_choice!" equ "y" (
					!bat_logexeclog! set bat_delete_bin_files=delete
				) else (
					if /i "!bat_choice!" equ "n" (
						!bat_logexeclog! set bat_delete_bin_files=keep
					)
				)

				!bat_logexec! dir "!bat_submissiondir!" /ad /b

				if not exist "!bat_submissiondir!\!bat_camera!\CapturedFiles" (
					!bat_echolog!
					!bat_echolog!
					!bat_echolog! WARNING - Camera number doesn't match Autocams option 2.  CONTINUING ANYWAY
					!bat_echolog!
					rem set bat_returncode=99
					rem goto :MAIN_END
				) else (
					rem This section deletes the thousands of ff*.bin files in the capturedfiles dir.  Hopefully, all the necessary
					rem files to reproduce anything will be in the archivedfiles and/or confirmedfiles dirs
					rem
					rem The problem is, it uses the bat_camera variable.

					if /i "!bat_delete_bin_files!" equ "delete" (
						!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissiondir!\!bat_camera!\CapturedFiles" /b /ad /on`^) do ^(
						for               /f "usebackq tokens=*" %%a in  (`dir "!bat_submissiondir!\!bat_camera!\CapturedFiles" /b /ad /on`) do (
							!bat_logexeclog! set bat_capturedfilesdir=!bat_submissiondir!\!bat_camera!\CapturedFiles\%%a

							!bat_pushecho! Permanently deleting "!bat_capturedfilesdir!\ff*.bin"
								if defined bat_capturedfilesdir (
									!bat_logexec! del /q "!bat_capturedfilesdir!\ff*.bin"
								) else (
									!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del /q "!bat_capturedfilesdir!\ff*.bin"
								)
							!bat_popecho!
						)
					)


					!bat_echolog! start "7za.exe" /wait /low /min "!bat_exedir!\7za.exe" a -tzip "!bat_targetfullzipfile!" "!bat_submissiondir!"
								  start "7za.exe" /wait /low /min "!bat_exedir!\7za.exe" a -tzip "!bat_targetfullzipfile!" "!bat_submissiondir!"
					set bat_returncode=!bat_logexec_returncode!

					if /i "!bat_returncode!" neq "0" (
						!bat_echolog! '    ERROR - Zip failed.
						rem goto :MAIN_END
					) else (
						!bat_echolog! '    SUCCESS - Zip returned a success code.

						!bat_logexec! dir "!bat_targetfullzipfile!" /b /a-d
						if not exist "!bat_targetfullzipfile!" (
							set bat_returncode=2
							!bat_echolog! '    ERROR - Zip failed to produce the output files
							rem goto :MAIN_END
						) else (
							!bat_echolog! '    SUCCESS - Zip created a target zip file [!bat_targetfullzipfile!]
							
							!bat_pushecho! Renaming the source directory to have the suffix of "_zipped":
								!bat_logexec! move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"
								set bat_returncode=!bat_logexec_returncode!
							!bat_popecho!
						)

					)

				)


				!bat_echolog! xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

			)&	rem End of bat_camera_loop_abort
		)&	rem for /f "usebackq tokens=*" ..c in (`dir "!bat_submissiondir!" /b /ad /on`) do...
		!bat_poplog! ^)
		
		!bat_logexeclog! set bat_camera=!bat_camera_save!

	)&	rem if exist "!bat_submissiondir!"

	!bat_logexec! call "!bat_exedir!\listdrives.bat"
	!bat_echolog!

:MAIN_END
!bat_poplog! [!bat_batchfile!:MAIN_END] [bat_returncode=!bat_returncode!]
goto :DONE %*














:HELP
	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]
	echo.
	echo Usage %~nx0 fullsourcedir
	echo.
	echo Example:
	echo   The following command will zip each directory for the month of
	echo   August, 2011 that exist under the SubmissionFiles directory...
	echo.
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "e:\cams\SubmissionFiles
	echo     \2011_08_??" /ad /b /on`^) do ^(call ^"c:\cams\zipdir_7za.bat^"  
	echo     ^"e:\cams\SubmissionFiles\%%a^"^)
	echo.
	echo   This will zip each dir that matches the filespec, "2011_08_??". It will 
	echo   rename the source directory to "source_zipped" if the zip is successful.  
	echo   Example: After running this for "2011_08_20", you will end up with the 
	echo            following:
	echo               2011_08_20_zipped    ^(Dir^)
	echo               2011_08_20.zip
	echo            
	echo.
	echo   It will not delete the original "2011_08_20" directory.  You will 
	echo   need to do that on your own.
	echo.
	echo   The compression ratio seems to be about 35%-40%
	echo.
	echo Note: This uses the Seven-Zip commandline utility ^(7za.exe^)
	echo.
exit /b -99

	
:DONE
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_log!
exit /b !bat_returncode!

