  @echo off
setlocal enabledelayedexpansion enableextensions

	rem NEEDS:
	rem       - 13. If submit.email.bat fails to create a Submit dir, then abort.

:CHECKHELP


	echo.%*|find /i "/?">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:


	
:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	set bat_logdir=!bat_exedir!\Logs
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&							rem C:

	call "!bat_exedir!\ReadParams.bat"

	

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_ftp_source_base_dir!

	!bat_logexeclog! call "!bat_exedir!\ReadConfig.bat"

	set bat_returncode=0

	!bat_logexeclog! type "!bat_paramsfile!"
	!bat_logexeclog! type "!bat_configfile!"
	
	set bat_ftp_command_file=!bat_exedir!\ftp_upload.txt
	

	call :PARSEARGS %*

	set bat_coinc_filename=FTPdetectinfo_Coinc.txt
	set bat_coinc_file_full=!bat_coinc_dir!\!bat_coinc_filename!
	
	set bat_coincP_filename=FTPdetectinfo_CoincMP.txt
	set bat_coincP_file_full=!bat_coinc_dir!\!bat_coincP_filename!

goto :MAIN




:MAIN
	call :READ_FTP_LOGIN
	if /i "!bat_returncode!" neq "0" goto :MAIN_END

	call :CHECKSOURCE
	if /i "!bat_returncode!" neq "0" goto :MAIN_END
	
	call :ZIPSOURCE
	if /i "!bat_returncode!" neq "0" goto :MAIN_END

	call :UPLOADFTP
	if /i "!bat_returncode!" neq "0" (
		goto :MAIN_END
	)


:MAIN_END
goto :DONE
!bat_return!

	
:PARSEARGS
	!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	echo.%*|find /i "autonomous"
	if !errorlevel! equ 0 (set bat_autonomous=autonomous)

	echo.%*|find /i ":">nul
	if !errorlevel! equ 0 (
		rem The user specified the full directory path
		!bat_logexeclog! set bat_coinc_dir=%~1
		rem Directory should have a file in it names "!bat_coinc_filename!"
	) else (
		rem The user specified only the date
		!bat_logexeclog! set bat_coinc_dir=!bat_exedir!\Temp\Coincidence\%~1
	)

	
	call "!bat_exedir!\PARSEDIR.BAT" "!bat_coinc_dir!"
	set bat_returncode=!errorlevel!

	if /i "!bat_returncode!" neq "0" (goto :PARSEARGS_END)

	!bat_logexeclog! set bat_date_coinc=!bat_retval2!
	!bat_logexeclog! set bat_coinc_parent_dir=!bat_retval1!

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [
!bat_log! '              bat_returncode=!bat_returncode!,
!bat_echolog! '              bat_coinc_dir=!bat_coinc_dir!,
!bat_echolog! '              bat_date_coinc=!bat_retval2!,
!bat_echolog! '              bat_coinc_parent_dir=!bat_retval1!]
!bat_log!
!bat_return!




:CHECKSOURCE
!bat_pushlog! [CALL !bat_batchfile!:CHECKSOURCE] %*
	set bat_returncode=0

	!bat_echolog! if not exist "!bat_coinc_file_full!" ^(
	if not exist "!bat_coinc_file_full!" (
		call :ERROR "!bat_coinc_file_full!" 6
		goto :CHECKSOURCE_END
	)
	
	set bat_zipdest_dir=!bat_coinc_dir!
	set bat_zipfile=!bat_zipdest_dir!\!bat_date_coinc!.zip
	!bat_logexeclog! set bat_zip=!bat_date_coinc!.zip

	if not exist "!bat_coinc_dir!\gefdat\SummaryOrbitLog.txt" (
		rem In this case, it would seem that Coincidence didn't run to completion
		rem Therefore, don't upload.
		set bat_returncode=12
		!bat_echolog! '   ERROR  [!bat_returncode!] - No ..\gefdat\SummaryOrbitLog.txt file
		goto :CHECKSOURCE_END
	)
	
	set bat_sizebad=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_coinc_dir!\gefdat\SummaryOrbitLog.txt" /s/b /a-d`) do (
		if %%~za leq 953 (
			!bat_logexec! echo [%%~za] bytes %%~a
			!bat_logexec! set bat_sizebad=true
		)
	)
	
	if defined bat_sizebad (
		rem In this case, either Coincidence didn't run to completion or
		rem no coinicidences were found.
		rem Therefore, don't upload.
		set bat_returncode=13
		!bat_echolog! '    ERROR  [!bat_returncode!] - SummaryOrbitLog.txt file is LEQ 953 bytes
		goto :CHECKSOURCE_END
	)

:CHECKSOURCE_END
!bat_poplog! [RETURN !bat_batchfile!:CHECKSOURCE] [bat_returncode=!bat_returncode!,
!bat_log! '           bat_zipdest_dir=!bat_zipdest_dir!,
!bat_log! '           bat_zipfile=!bat_zipfile!,
!bat_log! '           bat_zip=!bat_zip!]
!bat_log!
!bat_return!




:ZIPSOURCE
	set bat_returncode=0
	
	!bat_echolog! Going to create the zip file: !bat_zipfile!
	!bat_echolog!
	
	if not exist "!bat_coinc_dir!" (
		set bat_returncode=7
		set bat_recent_error_msg=ZipConcidence. ERROR - Source dir does not exist ["!bat_coinc_dir!"]
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		call :SAVECONFIG
		goto :ZIPSOURCE_END
	)

	if exist "!bat_coinc_dir!\temp" (
		if defined bat_coinc_parent_dir (
			!bat_logexec! del /q /s "!bat_coinc_parent_dir!\temp"
			!bat_logexec! rd /q /s "!bat_coinc_parent_dir!\temp"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:ZIPSOURCE] Dangerous command: del /q /s "!bat_coinc_parent_dir!\temp"
		)
	)

	!bat_logexec! md "!bat_coinc_parent_dir!\temp"
	
	!bat_logexec! xcopy "!bat_coinc_dir!\!bat_coinc_filename!" "!bat_coinc_parent_dir!\temp" /c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\!bat_coincP_filename!" "!bat_coinc_parent_dir!\temp" /c/f/r/y/h/i
	
	!bat_logexec! xcopy "!bat_coinc_dir!\cal*.txt" 							"!bat_coinc_parent_dir!\temp" 				/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\CameraSites*.txt" 					"!bat_coinc_parent_dir!\temp" 				/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\CameraTimeOffsets.txt" 				"!bat_coinc_parent_dir!\temp" 				/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\ff*.bin" 							"!bat_coinc_parent_dir!\temp" 				/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\w*.txt" 								"!bat_coinc_parent_dir!\temp" 				/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\Thumbnails*.bmp"                   "!bat_coinc_parent_dir!\temp" 				/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\EmailFiles\???_archived=*.txt" 		"!bat_coinc_parent_dir!\temp\EmailFiles" 	/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\EmailFiles\comments*.txt" 			"!bat_coinc_parent_dir!\temp\EmailFiles" 	/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\EmailFiles\LASTSETTINGS.txt" 		"!bat_coinc_parent_dir!\temp\EmailFiles" 	/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\EmailFiles\ReprocessParameters.txt" 	"!bat_coinc_parent_dir!\temp\EmailFiles" 	/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\EmailFiles\RadiantAssoc*.txt"      "!bat_coinc_parent_dir!\temp\EmailFiles"	/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\gefdat\*.*" 							"!bat_coinc_parent_dir!\temp\gefdat" 		/c/f/r/y/h/i
	!bat_logexec! xcopy "!bat_coinc_dir!\displayJPEGs\*.*" 					"!bat_coinc_parent_dir!\temp\displayJPEGs"	/c/f/r/y/h/i
	

	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"

	if defined bat_COINCIDENCE.password (
		set bat_coincidencepassword=-p!bat_COINCIDENCE.password!
	)


	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
	!bat_logexec! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_coinc_parent_dir!\temp\*" !bat_coincidencepassword!
	call :SEVENZIP_ERROR !bat_logexec_returncode!

	if !bat_returncode! neq 0 (
		set bat_returncode=8
		set bat_recent_error_msg=ZipLogs.ERROR - Failed to create the zip file using: "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog! '    errorlevel=!bat_returncode!
		!bat_echolog!
		!bat_echolog! '    Deleting empty zip file...
		call :SAVECONFIG
		
		if defined bat_zipfile (
			!bat_logexec! del /q "!bat_zipfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:ZIPSOURCE] Dangerous command: del /q "!bat_zipfile!"
		)
		goto :ZIPSOURCE_END
	)

	if exist "!bat_zipfile!" (
			rem Test for empty zip file...
		call :FTPHASH "!bat_zipfile!"
		if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
			set bat_returncode=9
			set bat_recent_error_msg=ZipLogs.ERROR - Empty zip file: "%~1" - deleting the zip file...
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog! '    errorlevel=!bat_returncode!
			!bat_echolog!
			call :SAVECONFIG
			
			if defined bat_zipfile (
				!bat_logexec! del /q "!bat_zipfile!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:ZIPSOURCE] Dangerous command: del /q "!bat_zipfile!"
			)
		) else (
			set bat_recent_error_msg=ZipLogs.SUCCESS - created "!bat_zipfile!"
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    Not a blank zip file...
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
			
			set bat_retval=!bat_recent_error_msg!
		)
	)


:ZIPSOURCE_END
!bat_poplog! [RETURN !bat_batchfile!:ZIPSOURCE] [bat_returncode=!bat_returncode!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!



:SEVENZIP_ERROR
!bat_pushlog! [CALL !bat_batchfile!:SEVENZIP_ERROR] [%*]
	if /i "%~1" equ "0" (goto :SEVENZIP_ERROR_END)

	if /i "%~1" equ "1" (
		set bat_error_msg='    ERROR [%~1] - 7ZIP - Warning [Non-fatal error[s]]. Example, one or more files may be locked so they were skipped
	)
	
	if /i "%~1 equ "2" (
		set bat_error_msg='    ERROR [%~1] - 7ZIP - Fatal error
	)
	
	if /i "%~1 equ "7" (
		set bat_error_msg='    ERROR [%~1] - 7ZIP - Command-line error
	)
	
	if /i "%~1 equ "8" (
		set bat_error_msg='    ERROR [%~1] - 7ZIP - Not enough memory for operation
	)
	
	if /i "%~1 equ "255" (
		set bat_error_msg='    ERROR [%~1] - 7ZIP - User stopped the process
	)
	
	set /a bat_returncode+=%~1
:SEVENZIP_ERROR_END
!bat_poplog! [RETURN !bat_batchfile!:SEVENZIP_ERROR] [bat_returncode=!bat_returncode! [%~1]]
!bat_log!
!bat_return!


	rem 17. Upload Zip via FTP ************************************
:UPLOADFTP
!bat_pushlog! [CALL !bat_batchfile!:UPLOADFTP] %*
	set bat_retval=failed
	set bat_returncode=0

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt


	call :FTPTRANSFER

	if exist "!bat_coinc_parent_dir!\temp" (
		if defined bat_coinc_parent_dir (
			!bat_logexec! del /q /s "!bat_coinc_parent_dir!\temp"
			!bat_logexec! rd /q /s "!bat_coinc_parent_dir!\temp"
		) else (
			set bat_recent_error_msg=ERROR [!bat_batchfile!:UPLOADFTP] Dangerous command: del /q /s "!bat_coinc_parent_dir!\temp"
			!bat_echolog! !bat_recent_error_msg!
			call :SAVECONFIG
		)
	)
	
:UPLOADFTP_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADFTP] [!bat_retval!, !bat_returncode!, "!bat_zipfile!" !bat_recent_error_msg!]
!bat_log!
!bat_return!







	rem Check for existing files on the server and download only those
	rem that don't match file names locally. 
:FTPTRANSFER
!bat_pushlog! [CALL !bat_batchfile!:FTPTRANSFER
	!bat_logexeclog! set bat_retval=failed


		REM Create the ftp command file for uploading the zip file
	!bat_echolog!

	!bat_echolog! Now upload the file
	!bat_pushecho!
	!bat_log! '    Note: Building the .ftp.temp_2.txt" file...
	
		echo user !bat_ftpuser!>"!bat_ftpfile!"
		echo !bat_ftppassword!>>"!bat_ftpfile!"
		echo bin>>"!bat_ftpfile!"
		echo cd !bat_ftpdir!>>"!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo put "!bat_zipfile!">>"!bat_ftpfile!"
		echo lcd "!bat_coinc_parent_dir!">>!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo get "!bat_zip!">>!bat_ftpfile!"
		echo quit>>"!bat_ftpfile!"
		
		!bat_logexec! type "!bat_ftpfile!"
	                   
		!bat_echolog! '..............................................
	!bat_popecho!

	!bat_logexec! call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
	set bat_returncode=!bat_logexec_returncode!

	!bat_echolog!
	!bat_echolog! '    FTP exit code=!bat_returncode!
	!bat_echolog!

::CHECK_GET
	if not exist "!bat_coinc_parent_dir!\!bat_zip!" (
		set bat_recent_error_msg=17.ERROR - Failed FTP upload of "!bat_zipfile!" - can't find it in "!bat_exedir!\Temp".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		call :SAVECONFIG
		goto :FTPTRANSFER_END
	) else (
		call :FTPHASH "!bat_zipfile!"
		set bat_hash_before=!bat_hash!
		
		call :FTPHASH "!bat_coinc_parent_dir!\!bat_zip!"
		set bat_hash_after=!bat_hash!
		
		if /i "!bat_hash_after!" neq "!bat_hash_before!" (
			set bat_returncode=9
			set bat_recent_error_msg=17.FAILED - Target is different from the source. Something went wrong between uploading the file and downloading it again to check.  The file exists on the FTP server, but when it is downloaded from the FTP server it is different from the original.
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog! '    "!bat_hash_before!" neq "!bat_hash_after!"
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
		) else (
			set bat_recent_error_msg=17.SUCCESS - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog! '    "!bat_hash_before!" equ "!bat_hash_after!"
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
		)
		
		!bat_pushecho! Deleting the test download...
		
		if defined bat_coinc_parent_dir (
			!bat_logexec! del /q "!bat_coinc_parent_dir!\!bat_zip!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q "!bat_coinc_parent_dir!\!bat_zip!"
		)
		
		if defined bat_zipfile (
			!bat_logexec! del /q "!bat_zipfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q "!bat_zipfile!"
		)
		!bat_popecho!

		if /i "!bat_hash_after!" neq "!bat_hash_before!" (
			goto :FTPTRANSFER_END
		)


		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		call :SAVECONFIG
	)

	                   
goto :FTPTRANSFER_END	

:FTPTRANSFER_END
!bat_poplog! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
!bat_return!





:CHECK_GET "!bat_exedir!\Temp\!bat_zip!" "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:CHECK_GET] %*
	!bat_logexeclog! set bat_checkget_zip=%~1
	!bat_logexeclog! set bat_checkget_zipfile=%~nx1
	
	if not exist "!bat_checkget_zip!" (
		set bat_recent_error_msg=17.ERROR - Failed FTP download of "!bat_checkget_zipfile!" - can't find it in "!bat_exedir!\Temp".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		call :SAVECONFIG
		goto :FTPTRANSFER_END
	)

	if not exist "!bat_exedir!\Temp\Zip" (
		md "!bat_exedir!\Temp\Zip"
	)

	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
			!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command:  del /s /q "!bat_exedir!\Temp\Zip"
		)
	)
	
	!bat_logexeclog! md "!bat_exedir!\Temp\Zip"
rem !bat_pause! Check if this dir exists: "!bat_exedir!\Temp\Zip"
	!bat_logexeclog! copy /y "!bat_checkget_zip!" "!bat_exedir!\Temp\Zip"
rem !bat_pause! Check if this file exists: "!bat_exedir!\Temp\Zip\!bat_checkget_zipfile!"


	call :FTP_TESTZIP "!bat_exedir!\Temp\Zip\!bat_checkget_zipfile!"
	if /i "!bat_returncode!" neq "0" (
		if defined bat_exedir (
			if defined bat_checkget_zip (
				del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
			)
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
		)
		goto :CHECK_GET_END
	)


	!bat_log!

	set bat_retval=success
	set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! '    !bat_recent_error_msg!
	!bat_echolog!
	!bat_echolog!
	call :SAVECONFIG


:CHECK_GET_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_GET] []
!bat_return!






:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

	!bat_echolog! 'Test the zip file before uploading to ensure that it's good.
	!bat_echolog! 'The test involves:
	!bat_echolog! '  - The zip file must exist;
	!bat_echolog! '  - The hash code must not be the empty zip file hash
	!bat_echolog! '    If so, the zip file will be deleted.
	!bat_echolog! '  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
	!bat_echolog! '    is cleaned out before unzipping]
	!bat_echolog! '  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
	!bat_echolog! '  - If there are no other errors, the 

	if not exist "%~1" (
		set bat_returncode=98
		set bat_recent_error_msg=17.ERROR - Not found: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		call :SAVECONFIG
		goto :FTP_TESTZIP_END
	)

	call :FTPHASH "%~1"
	if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
		set bat_returncode=99
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		call :SAVECONFIG
		
		if "%~1" neq "" (
			!bat_logexec! del /q "%~1"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /q "%~1"
		)
		goto :FTP_TESTZIP_END
	) else (
		!bat_echolog! '    not a blank zip file...
	)

%BAT_COMMENT_BEGIN%	
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
			!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
		)
	)
%BAT_COMMENT_END%

	!bat_log! // Unzip the file to "..\Temp\Zip" and check for errorlevel

rem !bat_pause! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*" !bat_coincidencepassword!
	set bat_returncode=!bat_logexec_returncode!
	!bat_echolog! bat_returncode=!bat_returncode!
rem !bat_pause! move /y "%~1" "!bat_exedir!\Temp"

	!bat_log! // Cleanup after unzipping...
	if exist "!bat_exedir!\Temp\Zip" (
		if /i "!bat_exedir!\Temp" neq "" (
			!bat_logexeclog! move /y "%~1" "!bat_exedir!\Temp"
			if defined bat_exedir (
				!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
				!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
			)
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] About to perform a dangerous delete command
			!bat_pause!
			exit /b -98
		)
	)

	!bat_log! // Comparing the hash codes...
	if /i !bat_returncode! equ 0 (
		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - Zip file is OK and ready to upload: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		call :SAVECONFIG
	) else (
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Corrupt zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		call :SAVECONFIG
		goto :FTP_TESTZIP_END
	)

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
!bat_return!








	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)
		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
	)
	
	if exist "!bat_exedir!\Logs\md5.output.log" (
		if defined bat_exedir (
			!bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTPHASH] Dangerous command: del /q "!bat_exedir!\Logs\md5.output.log"
		)
	)
	
:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!















:GETCALFILEINFO
!bat_pushlog! [CALL !bat_batchfile!:GETCALFILEINFO] %*
	call GetCalfileInfo.bat "!bat_calfilename!"
	set bat_returncode=!errorlevel!
!bat_poplog! [!bat_returncode!]
!bat_log!
!bat_return!






















	rem 48. Save Configuration ************************************
:SAVECONFIG

	!bat_logexeclog! "!bat_exedir!\SaveConfig.bat"

!bat_return!








:READCONFIGVAR
!bat_pushlog! [CALL !bat_batchfile!:READCONFIGVAR] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	set bat_tempvar=%~1

	!bat_push!
	for /f "usebackq tokens=* skip=2" %%x in (`find /i "!bat_tempvar!" "!bat_configfile!"`) do (
		!bat_log! set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)
	!bat_pop!

	
!bat_poplog! [RETURN !bat_batchfile!:READCONFIGVAR] [!bat_capturedfilesdir!]
	set bat_tempvar=
!bat_log!
!bat_return!



	rem 49. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
		color 07
	)
!bat_log!
!bat_return!





	








:VARIABLES
!bat_push!
	call "!bat_exedir!\show_bat_vars.bat"
!bat_pop!
	if not defined bat_autonomous (pause)
!bat_log!
!bat_return!






:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_pushecho! [CALL !bat_batchfile!:FIXDETECTPATHS] [%*]
	set bat_retval=0

	if /i "%~1" equ "" (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		call :SAVECONFIG
		goto :FIXDETECTPATHS_END
	)
	
	if /i {%2} equ {} (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		call :SAVECONFIG
		goto :FIXDETECTPATHS_END
	)

	!bat_logexec! call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!bat_logexec_returncode!
	if !bat_retval! lss 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		call :SAVECONFIG
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		call :SAVECONFIG
		!bat_echolog! !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_popecho! [RETURN !bat_batchfile!:FIXDETECTPATHS] [!bat_recent_error_msg!]
!bat_echolog!
!bat_return!


:READ_FTP_LOGIN
!bat_pushecho! [CALL !bat_batchfile!:READ_FTP_LOGIN] [%*]
	set bat_returncode=0
	set bat_ftppassword=
	set bat_ftpsite=
	set bat_ftpuser=
	set bat_ftpdir=

	if not exist "!bat_ftp_command_file!" (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    ERROR - Not exist: "!bat_ftp_command_file!"
		!bat_echolog!
		!bat_echolog!
		goto :READ_FTP_LOGIN_END
	)

	for /f "usebackq delims== tokens=1*" %%a in ("!bat_ftp_command_file!") do (
		!bat_logexeclog! set %%a=%%b
	)
	
	if not defined bat_ftppassword (call :ERROR "bat_ftppassword" 2&goto READ_FTP_LOGIN_END)
	if not defined bat_ftpsite (call :ERROR "bat_ftpsite" 3&goto READ_FTP_LOGIN_END)
	if not defined bat_ftpuser (call :ERROR "bat_ftpuser" 4&goto READ_FTP_LOGIN_END)
	if not defined bat_ftpdir (call :ERROR "bat_ftpdir" 5&goto READ_FTP_LOGIN_END)
	
:READ_FTP_LOGIN_END
!bat_popecho! [RETURN !bat_batchfile!:READ_FTP_LOGIN] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!




:ERROR
!bat_echolog! [CALL !bat_batchfile!:ERROR] [%*]
	set bat_returncode=%2
	!bat_pushecho!
	!bat_pushecho!
	!bat_echolog! ERROR - problem with "%~1" [%~1]
	!bat_popecho!
	!bat_popecho!
:ERROR_END
!bat_return!









	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed:
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!












:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.  Usage: %~nx0 "<coincidence directory>"
	echo.
	echo.  Zips, then uploads the coincidence files to the ftp server using the
	echo.  credentials specified in the ftp_upload.txt file. 
	echo.
	echo.  Example:
	echo.    %~0 "C:\CAMS\Temp\Coincidence\2013_08_11
	echo.
	echo.
exit /b -99


:DONE
!bat_pop!
	!bat_popecho!
	!bat_echolog! [!date! !time!] !bat_batchfile!:DONE with %0 %* [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!