@echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP
    echo.%*|find /i "/?">nul:
    if !errorlevel! equ 0 goto :HELP
    echo.!*|find /i "/h">nul:
    if !errorlevel! equ 0 goto :HELP
    echo.!*|find /i "/help">nul:
    if !errorlevel! equ 0 goto :HELP


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com

	set bat_returncode=0
	
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	
	if %yy% LSS 100 (
		rem Adds 2000 to two digit years)
		set /a yy+=2000
	)
	
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4

	if defined bat_log (
		!bat_pushlog! [%~0:ENDLOCAL  %*] [returning %~1=%JD%] 
		!bat_poplog!
	)
	
	set bat_returncode=%JD%

:date2jdate_END

ENDLOCAL & IF "%~1" NEQ "" (
				SET %~1=%JD%
				set bat_returncode=%JD%
			) ELSE (
				echo.%~0 return var is blank so:%JD%
				set bat_returncode=%JD%
			)
EXIT /b %bat_returncode%


:HELP
	echo.Usage: call :DATE2JDATE output_variable yyyy mm dd
	echo.
	echo.Returns: !JD!
	echo.
	echo.ERRORLEVEL also returns the JD value too or negative number if it can't calculate the JD.
	echo.
	echo.Example how to call it:
	echo.    call :date2jdate bat_jd 2014 03 21
	echo.    set bat_returncode=^^!errorlevel^^!
	echo.
	echo.    echo.^^!bat_jd^^!
	echo.    2456738
	echo.
exit /b -99