@echo off

rem RENAME THIS FILE TO FTP_Reprocesses.bat and store it in the C:\CAMS directory.
rem
rem This script needs to be modified (or a new script made) that allows batch
rem processing of multiple dates and/or processing of a date that is a date 
rem some other than the current date.
rem
rem It should be modified to run the check like ValidateCal does to ensure
rem that the Mean O-C number is less than 1.0.  It can do this by checking
rem the first two digits of the Mean O-C value for "0.".  (See ValidateCal.bat)
rem
rem It shold also check for valid .bin files like CheckBinFileSize.bat does. 
rem
rem It could also check that another ftp_reprocess.exe script is not already
rem running (because the process overwrites and will have a conflict with
rem some files in x:\cams. 
rem
rem Here is how this will be called from within FTP_Capture.bat:
rem 	echo  %date% %time% "FTP_Reprocess start" "!ftp_captureddir!" %1 %2 %3 %4>>"Logs\%~nx0.log"
rem 	title FTP_Reprocess
rem 	call "ftp_reprocess.bat" 1 "!ftp_captureddir!" "%3\CAMS\Cal"
rem			Where: 1                    - means copy ff*.bin files to ArchivedFiles
rem                "!ftp_captureddir!"  - is something like: 
rem                                         "h:\CAMS\CapturedDir\2011_08_21_20_30_43"
rem                "%3\CAMS\Cal"        - is something like:
rem                                         "h:\CAMS\Cal"
rem
rem 	echo  %date% %time% "FTP_Reprocess end" "!ftp_captureddir!" %1 %2 %3 %4>>"Logs\%~nx0.log"
rem
rem You should remember that the ArchivedFiles\datedir does not have the same date as
rem the CaptureFiles\datedir.  The datedir of CapturedFiles is the date/time when
rem FTP_Capture.exe is started, whereas the datedir of ArchivedFiles is the date/time
rem of the first file found in the CaptureFiles directory (that FTP_Reprocess.exe opens
rem and starts processing). Note: All date/times are in UTC.  Therefore, unless it is 
rem starting before 4pm (00:00:00 UTC), the date will actually have a value of
rem the following day.
rem 
rem TIPs: 
rem  This command returns the line that has the file count
rem   dir "C:\CAMS\SubmissionFiles\2011_08_04_06_04_11\ArchivedFiles\2011_08_04_06_04_11\*.bin"|find /i "!bat_AUTOCAMS.dir.files!"
rem Then, if you do  this command, using one less than the total files, you
rem will be able to get the first file name.
rem   for /f "usebackq tokens=* skip=360" %a in (`dir "C:\CAMS\SubmissionFiles\2011_08_04_06_04_11\ArchivedFiles\2011_08_04_06_04_11\*.bin" /s/b /o-d`) do (echo %a)
rem 

:SETUP
	setlocal enableextensions enabledelayedexpansion

:MAIN
	rem start the execution of the detection pass in background priority

	echo !date! !time!>"Logs\%~nx0.log"


	rem Note: 
	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	rem set /a ftp_jd=%ftp_jd%-1
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%


	set ftp_captureddir=%~1

	set ftp_

	rem Note: All date/times are in UTC.  Therefore, unless it is starting 
	rem before 4pm (00:00:00 UTC), the date will actually have a value of
	rem the following day.
	set /a ftp_linecount=0
	for /f "usebackq tokens=*" %%a in (`dir "!ftp_captureddir!\*.bin" /s/b /a-d^|sort /reverse`) do (
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"Logs\%~nx0.log"
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:SRCHDRIVEC
	for /f "usebackq tokens=*" %%a in (`dir "c:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"Logs\%~nx0.log"
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:CONTINUE


	@echo start "FTP_Reprocess" /wait "!bat_exedir_nonUS!\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%">>"Logs\%~nx0.log"
	 echo start "FTP_Reprocess" /wait "!bat_exedir_nonUS!\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%"
goto :DONE

:ERR1
	@echo.
	@echo.
	@echo "%cd%\ArchivedFiles\%ftp_archiveddir%" already exists. Do you want to
	@echo continue to overwrite the existing files? [Y/N] Y
	@goto :CONTINUE
	@set /p retval=continue to overwrite the existing files? [Y/N] 
	@if /i "%retval%" equ "y" goto :CONTINUE
goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0




:DONE
	echo !date! !time!>>"Logs\%~nx0.log"
