 @echo off
setlocal enabledelayedexpansion enableextensions
rem AutoCal.bat

goto :CHECKHELP

:CHECKHELP
	rem CONSTANTS


	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	
:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_logexeclog! call "!bat_exedir!\ReadConfig.bat" %*

	call "!bat_exedir!\ReadParams.bat"
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	
	set bat_returncode=0

	goto :MAIN %*
	
goto :DONE

	




:MAIN
!bat_pushlog! [CALL !bat_batchfile!:AUTOCAMS] [%*]
	rem This routine performs the following steps:
	
	if "!bat_camera!" equ "" set bat_camera=266

	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\CapturedFiles" /s/b /ad /on`) do (
		rem For each dir, process using the autocams ... autonomous command
		rem autocams.bat "c:\cam213\CAMS\CapturedFiles\2015_09_13_02_56_49" "c:\cam213\CAMS\ArchivedFiles\2015_09_13_02_56_49" 266 autonomous
		set bat_capturedfilesdir=%%~dpnxa
		
		set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!
		
		
		!bat_echolog! start "" /i /wait "cmd.exe" /c ""!bat_exedir!\autocams.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous"
		              start "" /i /wait "cmd.exe" /c ""!bat_exedir!\autocams.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous"
		
	)

goto :MAIN_END

:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] %*
!bat_log!
!bat_return!




	rem This next routine calls GetDetectFile.bat with the archivedfilesdir value.
	rem Then it does a meteor count using the find /i ".txt" method insted of the 
	rem the Find /i ".bin" method so that it can extract the latest cal file as well
	rem as the count.
:GETMETEORCOUNTARCHIVED
!bat_pushlog! [CALL !bat_batchfile!:GETMETEORCOUNTARCHIVED] %*
	set /a bat_archivedmeteorcount=0
	!bat_logexeclog! call "GetDetectFile.bat" "bat_detectfile" "!bat_archivedfilesdir!"
	if not exist "!bat_detectfile!" (
		set bat_latestcal=

		goto :GETMETEORCOUNTARCHIVED_END
	)
	
		rem Remember - there may be more than one camera in the file
	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_log! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_detectfile!"`^) do ...
	for           /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_poplog! [RETURN !bat_batchfile!:GETMETEORCOUNTARCHIVED] [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_detectfile!]
!bat_log!
!bat_return!



	rem 7b. Cal Auto Update ********************************************
:CALUPDATEAUTO
!bat_pushlog! [CALL !bat_batchfile!:CALUPDATEAUTO] %* [bat_archivedmeteorcount=!bat_archivedmeteorcount!]

	set bat_retval=failed

	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog!
		!bat_echolog! '    You probably don't want to do this - you have already run Submission: 
		if not defined bat_autonomous (
			set /p bat_choice=[Enter] to quit, 
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=[!bat_returncode!]
			goto :CALUPDATEAUTO_END
		)
	)
	
	rem Should be something like:
	rem   call :autocalupdate.bat 100 1.00 "!bat_caldir!" "!bat_capturedfilesdir!"
	rem
	rem And then check the autocal log for success/failure


	if /i "!bat_archivedmeteorcount!" LSS "0" (
		!bat_echolog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
		goto :CALUPDATEAUTO_END
	) else (
			rem Don't use bat_logexec here because we want to watch it run.
		!bat_log! start /low /wait "" !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
		          start /low /wait "" !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
		set bat_returncode=!errorlevel!
	!bat_log!
	!bat_log! Returned from FTP_MeteorCal_AutoUpdate.exe [bat_returncode=!bat_returncode!]
	!bat_log!

			rem Check for the case where the autocal exe was aborted or canceled during
			rem autocal.  In such case, the file is empty or truncated.
		if not exist "!bat_capturedfilesdir!\AutoCalUpdate.log" (
			set bat_retval=failed
			set bat_returncode=2
			!bat_echolog!
			!bat_echolog! '    ERROR - AutoCal failed - Not Found
			!bat_echolog! '            "!bat_capturedfilesdir!\AutoCalUpdate.log"
			!bat_echolog!
			goto :CALUPDATEAUTO_END
		) else (
				rem Check for the case where the autocal exe is aborted or canceled during
				rem autocal.  In such case, the file will be smaller than 560 bytes. 
			for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\AutoCalUpdate.log" /s/b /a-d`) do (
				!bat_echolog! %%~a, %%~za
				if %%~za leq 560 (
					set bat_retval=failed
					set bat_returncode=3
					!bat_echolog!
					!bat_echolog! '    ERROR - AutoCal failed - Less than 560 bytes
					!bat_echolog! '            "!bat_capturedfilesdir!\AutoCalUpdate.log"
					!bat_echolog!
					!bat_logexec! type "!bat_capturedfilesdir!\AutoCalUpdate.log"
					goto :CALUPDATEAUTO_END
				) else (
					set bat_retval=executed
				)
			)
		)
	)
	
	!bat_log! Autocal status: [bat_retval=!bat_retval!]
	!bat_log!

		rem Check for the case where no calibrations were found or the exe was 
		rem aborted or terminated early. This could be a common practice because
		rem the user might see  that something is wrong and then hit CTRL+C.
	find /i /c "Auto-Calibrating Cam Number " "!bat_capturedfilesdir!\AutoCalUpdate.log">nul: 2>&1
	if !errorlevel! neq 0 (
		set bat_retval=failed
		set bat_returncode=4
		!bat_echolog!
		!bat_echolog! '    ERROR - AutoCal failed - criteria not met
		!bat_echolog! '            "!bat_capturedfilesdir!\AutoCalUpdate.log"
		!bat_echolog!
		!bat_logexec! type "!bat_capturedfilesdir!\AutoCalUpdate.log"
		goto :CALUPDATEAUTO_END
	)


	!bat_pushecho! Validate the AutoCalUpdate.log file for each camera....
	for /f "usebackq tokens=1-12 skip=2" %%a in (`find /i "camera " "!bat_capturedfilesdir!\AutoCalUpdate.log"`) do (
		set bat_autocal_success=0

			rem There are only two types of lines that have the "camera " text on it:
			rem   1) A line with "Auto-Calibrating Camera Number xxx"
			rem   2) One or more lines with the camera success/failed records

		if /i "%%a" neq "Auto-Calibrating" (
			!bat_echolog! %%a %%b %%c %%d, %%e %%f %%g %%h %%i

			if /i "%%a" equ "camera" (
				set bat_autocal_camera=%%b
				set bat_autocal_success=%%c
				set bat_autocal_nstars=%%d
				set bat_autocal_oc=%%e
				set bat_autocal_fffile=%%f
				set bat_autocal_calfile=%%g

				if !bat_autocal_oc! GTR !bat_caloc! (
					set bat_autocal_success=1
					set bat_returncode=1
					set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - ERROR   O-C !bat_autocal_oc! GTR !bat_caloc!
					!bat_push!
						!bat_echolog!
						!bat_echolog! !bat_recent_error_msg!
						!bat_echolog!
						!bat_echolog! Camera:	!bat_autocal_camera!
						!bat_echolog! Success:	FAILED
						!bat_echolog! nStars:	!bat_autocal_nstars!
						!bat_echolog! O-C:	!bat_autocal_oc!
						!bat_echolog! FF file:	!bat_autocal_fffile!
						!bat_echolog! calfile:	!bat_autocal_calfile!
						!bat_echolog!
					!bat_pop!

					rem Delete the cal file if the O-C value is too high, even though
					rem the .exe program thinks it's ok. 
					if "!bat_autocal_calfile!" neq "" (
						if exist "!bat_caldir!\!bat_autocal_calfile!" (
							if defined bat_caldir (
								if defined bat_autocal_calfile (
									!bat_logexec! del /q "!bat_caldir!\!bat_autocal_calfile!"
								) else (
									!bat_echolog! ERROR [!bat_batchfile!:CALUPDATEAUTO] Dangerous command: del /q "!bat_caldir!\!bat_autocal_calfile!"
								)
							) else (
								!bat_echolog! ERROR [!bat_batchfile!:CALUPDATEAUTO] Dangerous command: del /q "!bat_caldir!\!bat_autocal_calfile!"
							)
						)
					)

					!bat_echolog! '    !bat_recent_error_msg!
				)& rem !bat_autocal_oc! GTR !bat_caloc!
	
				if /i "!bat_autocal_success!" neq "0" (
					set bat_returncode=1
					!bat_echolog! '    set bat_returncode=[!bat_returncode!]
					set bat_recent_error_msg=ERROR - 7b.a. Auto Calibration failed
					!bat_echolog! '    !bat_recent_error_msg!
				) else (
					!bat_push!
						!bat_echolog!
						!bat_echolog! Camera:	!bat_autocal_camera!
						!bat_echolog! Success:	SUCCESS
						!bat_echolog! nStars:	!bat_autocal_nstars!
						!bat_echolog! O-C:		!bat_autocal_oc!
						!bat_echolog! FF file:	!bat_autocal_fffile!
						!bat_echolog! calfile:	!bat_autocal_calfile!
						!bat_echolog!
					!bat_pop!
					set bat_recent_error_msg=SUCCESS - 7b. Auto Calibration successful [!bat_autocal_calfile!, !bat_autocal_nstars!, !bat_autocal_oc!]
					!bat_echolog! '    !bat_recent_error_msg!
				)
	
				!bat_echolog!
			)
		)
	)
	!bat_popecho! End of validation...
	

:CALUPDATEAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:CALUPDATEAUTO] [!bat_retval!, !bat_returncode!]
!bat_log!
!bat_return!





:CALC_CAL_VALUES
	set bat_calra=%~1
	set bat_caldec=%~2
	set bat_choice=%~3
	set bat_time=%~4

	rem calculate the entered time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~0,2! bat_hh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~2,2!00 bat_mm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~4,2!00 bat_ss

	echo set /a "bat_hour=((!bat_ss! / 60) + !bat_mm!) / 60) + !bat_hh!00"
		 set /a "bat_mmdecimal=((!bat_ss! / 60) + !bat_mm!) / 60"
	set /a bat_hour=!bat_hh!00 + !bat_mmdecimal!
	set bat_hourdisplay=!bat_hh!.!bat_mmdecimal!


	rem calculate the old cal file time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~0,2! bat_timehh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~3,2!00 bat_timemm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~6,2!00 bat_timess

	set /a "bat_timemmdecimal=((!bat_timess! / 60) + !bat_timemm!) / 60"
	set /a bat_timetotal=!bat_timehh!00+!bat_timemmdecimal!
	set bat_timemmdecimal=!bat_timemmdecimal!0000
	set bat_timemmdecimal=!bat_timemmdecimal:~0,4!
	set bat_timetotal=!bat_timehh!!bat_timemmdecimal!

	set /a bat_timediff=!bat_hour!00 - !bat_timetotal!
	set /a bat_diffdegrees=!bat_timediff! * 15


	rem Caluclate the new RA value based on the difference in hours
	set bat_temp2=
	call "!bat_exedir!\STRIPZEROS.bat" !bat_calra! bat_calra
	for /f "usebackq tokens=1,2 delims=." %%a in ('!bat_calra!') do (
		set bat_radeg=%%a
		set bat_radegdecimal=%%b

		set bat_temp2=!bat_radegdecimal!0000
		set bat_temp2=!bat_temp2:~0,4!
		set bat_ratotal=!bat_radeg!!bat_temp2!

		set /a bat_ranew=!bat_ratotal! + !bat_diffdegrees!
		if !bat_ranew! GEQ 3600000 (
			set /a bat_ranew=3600000 - !bat_ranew!
		)
	)

	echo.
	echo     Data from current calibration file: !bat_detectcalfile!
	echo        time=!bat_time!, !bat_timetotal!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!
	echo        RA  =!bat_retval1!, !bat_ratotal!
	echo        DEC =!bat_retval2!
	echo.
	rem echo     bat_timediff=!bat_timediff!
	rem echo     bat_diffdegrees=!bat_diffdegrees!
	rem echo.
	echo     Data from the FF file based on the entered time segment: !bat_choice!
	echo        time=!bat_hour:~0,-2!.!bat_hour:~-2!
	echo        RA  =!bat_ranew!
	echo        DEC =!bat_caldec!
	echo.

		
:CALC_CAL_VALUES_END
rem echo [RETURN !bat_batchfile!:CALC_CAL_VALUES] [in=%*] [!bat_timetotal!, !bat_hour!, !bat_ranew!, !bat_diffdegrees!]
!bat_return!


	rem 9. Apply cal to detectinfo *******************************
:APPLY
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :APPLY_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :APPLY_END
	)
	
	set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_detectfile!" (
		set bat_detectfile=FTPdetectinfo.txt
		if not exist "!bat_detectfile!" (
			!bat_echolog! '    ERROR - Can't find detect file: "!bat_detectfile!"
			goto :APPLY_END
		)
	)
	
	!bat_logexeclog! call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"

	set bat_latestcal=
	!bat_pushlog! for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_detectfile!"`^) do...
	for               /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile!"`) do (
		if not defined bat_latestcal (
			set bat_latestcal=%%a
			!bat_echo!
			!bat_echo! '   Reading the current FTPdetectinfo.txt file and scanning for the cal
			!bat_echo! '   file now in use...
			!bat_echo! '      "!bat_latestcal!"
		)
	)


:APPLY_END
	pause
!bat_return!



	rem 9. Apply cal to detectinfo *******************************
:APPLYAUTO
!bat_echolog! [CALL !bat_batchfile!:APPLYAUTO] %*
	set bat_retval=failed
	set bat_latestcal=

	if "!bat_archivedmeteorcount!" equ "0" (
		!bat_errorlog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous
						    call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous>nul:
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			!bat_echolog! '    ERROR ApplyCal.bat failed
			goto :APPLYAUTO_END
		)

	set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
		set bat_detectfile=FTPdetectinfo.txt
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			!bat_echolog! '    ERROR - Can't find detect file: "!bat_archivedfilesdir!\!bat_detectfile!"
			goto :APPLYAUTO_END
		)
	)

		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...>>"!bat_logfile!"
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
		for      /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
			if not defined bat_latestcal (
				set bat_latestcal=%%a
			)
		)
	)

	!bat_echolog! '    Cal file in "!bat_archivedfilesdir!\!bat_detectfile!":
	!bat_echolog! '    "!bat_latestcal!"
	if defined bat_latestcal (
		set bat_retval=success
	)
	
:APPLYAUTO_END
!bat_echolog! [RETURN !bat_batchfile!:APPLYAUTO] [!bat_retval!, "!bat_latestcal!"]
!bat_log!
!bat_return!






:GETCONFIRMEDCOUNT
!bat_pushlog! [CALL !bat_batchfile!:GETCONFIRMEDCOUNT] %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile_conf=!bat_detectfile:ArchivedFiles=ConfirmedFiles!
	call "!bat_exedir!\ParseDir.bat" "!bat_detectfile_conf!"
	set bat_detectfile_conf_name=!bat_RetVal2!
	
	
	if not exist "!bat_confirmedfilesdir!" (
		goto :GETCONFIRMEDCOUNT_END
	)


	if not exist "!bat_detectfile_conf!" (
		set bat_detectfile_conf=!bat_detectfile_conf!\FTPdetectinfo.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile_conf!" (
			goto :GETCONFIRMEDCOUNT_END
		)
	)

	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_pushlog! for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".bin" "!bat_detectfile_conf!"`^) do ...
	for               /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile_conf!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)
	!bat_pop!

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_poplog! [RETURN !bat_batchfile!:GETCONFIRMEDCOUNT] [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, bat_detectfile_conf=!bat_detectfile_conf!]
!bat_log!
!bat_return!


	rem 12. Apply cal to ConfirmedFiles **************************
:APPLYCONFIRMED
	set bat_returncode=0
	set bat_retval=failed
	set bat_latestconfcal=
	set bat_detectfileconf=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_returncode=1
		echo.
		!bat_echolog! '    ERROR - 12. Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		set bat_returncode=1
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		echo.
		!bat_echolog! '    ERROR - 12. You need to Choose ArchivedFiles first:
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)
	
	!bat_echolog! '    bat_archivedfilesdir=!bat_archivedfilesdir!
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	!bat_echolog! '    bat_confirmedfilesdir=!bat_confirmedfilesdir!
	if not exist "!bat_confirmedfilesdir!" (
		!bat_echolog! '    ERROR - Confirmed dir not found: "!bat_confirmedfilesdir!"
		goto :APPLYCONFIRMED_END
	)
	
	if "!bat_confirmedmeteorcount!" equ "0" (
		set bat_returncode=1
		!bat_errorlog! '    NOTE - 12. Confirmed Meteor Count is 0. Nothing to calibrate.
		goto :APPLYCONFIRMED_END
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
						    call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			!bat_echolog! '    ERROR 12. ApplyCal.bat failed
			goto :APPLYAUTO_END
		)

		if not exist "!bat_confirmedfilesdir!\!bat_detectfileconf!" (
			set bat_detectfileconf=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfileconf!" (
				!bat_echolog! '    ERROR - 12. detect file not found: "!bat_confirmedfilesdir!\!bat_detectfileconf!"
				goto :APPLYCONFIRMED_END
			)
		)
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfileconf!"`^) do ...>>"!bat_logfile!"
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfileconf!"`^) do ...
		for      /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfileconf!"`) do (
			if not defined bat_latestconfcal (
				set bat_latestconfcal=%%a
			)
		)
	)


	!bat_echolog! '    Cal file in "!bat_confirmedfilesdir!\!bat_detectfileconf!":
	!bat_echolog! '    "!bat_latestconfcal!"
	if defined bat_latestconfcal (
		set bat_retval=success
	)

	
:APPLYCONFIRMED_END
	if not defined bat_autonomous (
		pause
	)
!bat_return!





:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_pushlog! [CALL !bat_batchfile!:GETFILECOUNT] "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_poplog! [RETURN !bat_batchfile!:GETFILECOUNT] [%~1=!%1!]
!bat_log!
!bat_return!



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
!bat_return!



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
!bat_return!




:SEARCHFORDIR [out] bat_retval [out] bat_retval2[in]  [out] bat_retval3 bat_basedir
	rem bat_retval	is a fully qualified directory name
	rem bat_retval2 is that path not including the last directory name of the path
	rem bat_retval3 is the last directory name in the path
	
	echo :SEARCHFORDIR "%~1" 
	set bat_retval= 
	for /f "usebackq tokens=*" %%a in (`dir "%~1" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)

!bat_log! [RETURN !bat_batchfile!:SEARCHFORDIR] [bat_retval=!bat_retval!, bat_retval2=!bat_retval2!, bat_retval3=!bat_retval3!]
!bat_log!
!bat_return!




	rem 18. Email notice ******************************************
:EMAILTEXT
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	echo.
	echo Email the following text to your central coordinator:
	echo.
	echo     Subject: CAMS submission for Camera !bat_camera! for !bat_captureddate!
	echo.

	echo     The CAMS files for Camera !bat_camera! for Capture Date of !bat_captureddate! 
	echo     have been processed.  
	echo.
	echo     Please let me know if anything of significance was found using this data.
	echo.
	echo     Details for the submission follow...
	echo.
	echo     Scanning for zip files in ["!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"]...
	set bat_zipfile=
	if exist "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /on`) do (
			set bat_zipfile=!bat_targetlocation!\CAMS\Transmitted\%%~a
		)
		
		if defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS been uploaded 
			echo       to the FTP server.  The file name is:
			echo          "!bat_zipfile!"
		)
	) else (
		if not defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS NOT been  
			echo       uploaded.  The file name should have been:
			echo          "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"

			echo.
			if exist "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" (
				echo       Scanning for zip files in ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]...
				set bat_zipfile2=
				for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /on`) do (
					set bat_zipfile2="!bat_targetlocation!\CAMS\Submitted\%%~a"
				)
				if defined bat_zipfile2 (
					echo         The zip file was created here, but was not uploaded:
					echo            "!bat_zipfile2!"
				)
			)
		)
	)
	
	echo.
	echo.
	set bat_emailfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles
	for /f "usebackq tokens=*" %%h in (`dir "!bat_emailfilesdir!\arch*.txt" /b`) do (
		for /f "tokens=1-6 delims=.,=" %%i in ("!bat_emailfilesdir!\%%h") do (
			echo                     Archived    Confirmed
			echo     Meteor Count    %%j          %%l
		)
	)

	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt" /b /od /a-d`) do (
		set bat_calfilename=!bat_submissionfilesdir!\!bat_camera!\Cal\%%h
	)

	for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt"`) do (
		set bat_found=0
		if "%%h" equ " Camera number            " (set bat_found=1)
		if "%%h" equ " Calibration date         " (set bat_found=1)
		if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
		if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
		if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
		if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
		if "%%h" equ " Mean O-C " (set bat_found=1)
		if !bat_found! equ 1 (
			set bat_temp=%%~h                              
			set bat_temp=!bat_temp:~0,27!
			echo  !bat_temp! =%%i
		)
	)



	
::GETCALFILENSTARS	
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	echo   Cal stars used             = !bat_calfilestars!

:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
!bat_return!



:CHECKBINFILESIZE
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
!bat_return!






	rem 6u. ValidateCal ********************************************
:VALIDATECAL
	set bat_temp=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

	set bat_targetfilespec=!bat_caldir!\CAL???_*.txt

	if defined bat_captureddate (
		set bat_targetfilespec=!bat_caldir!\CAL!bat_camera!_!bat_temp!*.txt
	)

	if defined bat_latestcal (
		echo.
		echo   Current CAL file information is:
		echo   bat_camera=!bat_camera!
		echo   bat_latestcal=!bat_latestcal!
		set bat_targetfilespec=!bat_caldir!\!bat_latestcal!
		shift
		shift
	)

	echo call ValidateCal.bat /cal "!bat_targetfilespec!"
	     call ValidateCal.bat /cal "!bat_targetfilespec!"

	pause
!bat_return!





	rem 18u. Save Configuration ************************************
	rem 
	rem Note: No longer does anything
	rem 

:SAVECONFIG
rem !bat_echolog! [CALL !bat_batchfile!:SAVECONFIG] %*
rem !bat_echolog! [RETURN !bat_batchfile!:SAVECONFIG
!bat_return!






	rem u19. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
	)
!bat_return!



:VARIABLES
	set bat_
	pause
!bat_return!


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_pushlog! [CALL !bat_batchfile!:FIXDETECTPATHS] [%*, !bat_detectfile!]
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)

	!bat_logexeclog! call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	if !bat_logexec_returncode! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file ""%~1\%2"
		goto :FIXDETECTPATHS_END
	)
:FIXDETECTPATHS_END
!bat_poplog! [RETURN !bat_batchfile!:FIXDETECTPATHS] []
!bat_log!
!bat_return!



=============================================
======== JUNK TO THROW OUT ==================
=============================================

:GETCAMERAFROMCAPTURED
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMCAPTURED] %*
	set /a bat_capturedcount=0
	!bat_log! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for           /f "usebackq tokens=*" %%a in  (`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_capturedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)

!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMCAPTURED] [bat_camera=!bat_camera, bat_capturedcount=!bat_capturedcount!]
!bat_log!
!bat_return!



	rem a. AutoCams  ***************************
:AUTO
!bat_pushlog! [CALL !bat_batchfile!:AUTO] %*
	!bat_echolog! start "autocams" autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
	              start "autocams" autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
!bat_poplog! [RETURN !bat_batchfile!:AUTO] [!bat_capturedfilesdir!]
!bat_log!
!bat_return!



	rem 5. SkippedFrames ******************************************
:SKIPPEDFRAMES
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\skippedFrames.bat "!bat_capturedfilesdir!" /v
	     call !bat_exedir!\SkippedFrames.bat "!bat_capturedfilesdir!" /v

	cd /d !bat_exedir!
	
	pause
!bat_return!



::SHOWSKIPPEDFRAMES
	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
						 call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
				)
			)
		)
	)
	pause
!bat_return!
goto :EOF



:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		rem set bat_camera=!bat_temp:~2,3!
	)
!bat_return!










:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!








^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^






:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "capturedfilesdir" "archivedfilesdir" camera [Nstars  O-C]  [autonomous]
	echo.
	echo.Iterates through all CapturedFiles dirs and runs autocams.bat ... autonomous for
	echo.each.
	echo.
	echo.
	echo.
exit /b -99



:DONE
	call :SAVECONFIG
	!bat_popecho!
	!bat_echolog! [!bat_batchfile!:DONE]Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! [!bat_batchfile!:DONE] exit /b !bat_returncode!

	exit /b !bat_returncode!
