 @echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
	if "%~1" equ "" goto :HELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	if defined bat_batchfile (
		call "%~dp0AutoCams.setup.bat" "!bat_batchfile!"
	) else (
		call "%~dp0AutoCams.setup.bat" "%~f0"
	)

	call "%~dp0indent_setup.bat" "%~dpnx0"

	call "!bat_exedir!\ReadParams.bat"

    
    set bat_caldir=!bat_exedir!\Cal
    set bat_skippedframes_tempfile=!bat_logdir!\skippedframes.summary.log
    
    if not defined bat_logdir (
    	!bat_echolog! ERROR - bat_logdir is blank
    	exit /b -98
    )
    
     if defined bat_skippedframes_tempfile (
		del /q "!bat_skippedframes_tempfile!"
		!bat_echolog!
    ) else (
    	!bat_echolog! ERROR - bat_skippedframes_tempfile is blank
    	exit /b -98
    )
   

	set bat_verbose=
	set bat_OK=



	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	call :PARSEARGS %*
goto :MAIN




:MAIN
	set bat_stars=*****************************************************************
	set /a bat_prevsecs=0
	set /a bat_skippedtotal=0
	set /a bat_filecount=0
	set /a bat_filecount_camera=0
	set    bat_skipped_lastfile=
	
	set bat_camera_prev= 
	
	for /f "usebackq tokens=*" %%a in (`dir "!bat_sourcedir!\ff*.bin" /b /on`) do (
		set /a bat_filecount+=1
		set bat_file=%%a
		set bat_tcamera=!bat_file:~2,3!


		if !bat_filecount! equ 1 (
			set bat_camera_prev=!bat_tcamera!
			set bat_skipped_lastfile=%%nxa
			call :GETFPS !bat_tcamera!
		)
		
		if /i "!bat_tcamera!" equ "!bat_camera_prev!" (
			set bat_skipped_lastfile=!bat_file!
		)


		if /i "!bat_tcamera!" neq "!bat_camera_prev!" (
			rem If it's the first line...
			if !bat_filecount_camera! equ 1 (
				TITLE File count: 0  Skipped count: 0 for camera !bat_tcamera!
				
				set bat_startingtime=!bat_prevsecs!
				call :GETFPS !bat_tcamera!
				set bat_camera=!bat_tcamera!
				set bat_skipped_lastfile=%%nxa
			) else (
				call :CAMERASUMMARY
				set bat_skipped_lastfile=!bat_file!
				set /a bat_framespersec=0
				set /a bat_skippedtotal=0
				
				call :GETFPS !bat_tcamera!

				TITLE File count: !bat_filecount!  Skipped count: !bat_skippedtotal! for camera !bat_tcamera!
			)

			set bat_camera_prev=!bat_tcamera!
			set bat_filecount_camera=0
		)
		
		set /a bat_filecount_camera+=1

	if !bat_filecount_camera! equ 1 (
		set bat_skipped_firstfile=%%a
		echo Seconds for 256 frames per FF file at !bat_camera_framerate:~0,-2!.!bat_camera_framerate:~-2! fps = [!bat_fps:~0,-3!.!bat_fps:~-3! secs]
		echo    ^(anything slower than that implies skipped frames^)
		echo.
		if !bat_verbose! equ true (
			echo File Name                                Day secs    FF sec	Message
			echo -------------------------------------    ---------   ------	-------------------------------------------
		)
	)&	rem for...

		rem Get timestamp
		set bat_hh=!bat_file:~15,2!
		set bat_mm=!bat_file:~17,2!
		set bat_ss=!bat_file:~19,2!
		set bat_ssms=!bat_file:~22,3!

		rem strip leading zeros
		set /a "bat_h=100!bat_hh! %% 100"
		set /a "bat_m=100!bat_mm! %% 100"
		set /a "bat_s=100!bat_ss! %% 100"
		set bat_sms=!bat_s!!bat_ssms!
		
		set /a "bat_secs=bat_h*3600+bat_m*60+bat_s"
		set bat_secs2=!bat_secs!!bat_ssms!
		set bat_secs3=!bat_secs!.!bat_ssms!
		set bat_current=!bat_hh!!bat_mm!!bat_ss!!bat_ssms!

rem echo.
rem echo.%%a, bat_ssms=!bat_ssms!, bat_sms=!bat_sms!, bat_secs2=!bat_secs2!
		if "!bat_prevsecs!" equ "0" (
			set bat_prevsecs=!bat_secs2!
		)

		set /a "bat_delta=bat_secs2-bat_prevsecs"
		if !bat_delta! LSS !bat_fps! (
			set bat_delta=!bat_fps!
		)
		rem set /a bat_skipcount"=(bat_delta-!bat_fps!) / 33"
		set /a bat_skipcount"=(bat_delta-!bat_fps!)*!bat_camera_framerate!/100000"

		set bat_msg=  
		
		if "!bat_skipcount!" gtr "0" (
			set bat_msg=skipped !bat_skipcount!
		)
		
		set bat_deltad=        !bat_delta:~0,-3!.!bat_delta:~-3!
		set bat_deltad=!bat_deltad:~-7!
		
		set bat_secs2d=        !bat_secs2:~0,-3!.!bat_secs2:~-3!
		set bat_secs2d=!bat_secs2d:~-12!
		
		set bat_prevsecsd=        !bat_prevsecs:~0,-3!.!bat_prevsecs:~-3!
		set bat_prevsecsd=!bat_prevsecsd:~-12!
		
		if "!bat_skipcount!" gEQ "1" (
			if "!bat_skipcount!" EQU "1" (
				set bat_skipcount=1
				set bat_skipcount2=1
			) else (
					set /a "bat_skipcount2=bat_skipcount*10/12+5"
					set bat_skipcount2=!bat_skipcount2:~0,-1!
					
					if !bat_skipcount2! lss 3 (
						set /a bat_skipcount2=2
					)
			)

			call :SETSTARS !bat_skipcount2!
			if !bat_verbose! equ true (
				echo !bat_file! !bat_secs2d!  !bat_deltad!	!bat_msg!
			)
		) else (
			if !bat_OK! equ true (
				echo !bat_file! !bat_secs2d!  !bat_deltad!	!bat_msg!
			)
		)


		if not defined bat_startingtime (
			set /a bat_startingtime=bat_secs2
		)
		
		set /a bat_endingtime=bat_secs2
		
		set /a bat_skippedtotal+=bat_skipcount
		
		if "!bat_skipcount!" gtr "0" (
			title File count: !bat_filecount!  Skipped count: !bat_skippedtotal! for camera !bat_tcamera!
		)

		set bat_prevsecs=!bat_secs2!
		
		set /a "bat_rem=bat_filecount %% 200"
		if !bat_rem! equ 0 (
			title File count: !bat_filecount!  Skipped count: !bat_skippedtotal! for camera !bat_tcamera!
		)

		if "!bat_tcamera!" neq "!bat_camera_prev!" (
			if !bat_filecount_camera! GTR 1 (
				call :CAMERASUMMARY
				set bat_camera_prev=!bat_tcamera!
			)
		)
	)& rem for ...

	call :CAMERASUMMARY


	!bat_logexeclog! find /v "" "!bat_skippedframes_tempfile!"
	!bat_poplog!

	if defined bat_skippedframes_tempfile (
        !bat_logexeclog! del /q "!bat_skippedframes_tempfile!"
		!bat_echolog!
	) else (
		!bat_echolog! ERROR - bat_skippedframes_tempfile is blank
		exit /b -98
	)


	!bat_pop!
	!bat_echolog! END OF %~nx0  ******  %date% %time%
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:MAIN_END
exit /b






:CAMERASUMMARY
	set /a bat_totalsecs=bat_endingtime-bat_startingtime
	if !bat_totalsecs! lss 0 (
		set /a "bat_totalsecs=(86400000 - !bat_startingtime!) + !bat_endingtime!"
	)

	set /a bat_totalmin=bat_totalsecs/60
	set /a bat_totalhrs=bat_totalsecs/3600

	rem trucate down to three digits
	call "str_math.bat" "(!bat_skippedtotal!*60000/(!bat_totalsecs!))*1000">nul: 2>&1
	set /a "bat_avgskipped=!bat_retval!*1">nul: 2>&1
	call "str_math.bat" !bat_avgskipped!/1000>nul: 2>&1
	set bat_avgskipped=!bat_retval!

	
	if !bat_filecount! equ 0 (
		set bat_avgskippedperfile=0.0
	) else (
		call "str_math.bat" "!bat_skippedtotal!/!bat_filecount_camera!*1000">nul: 2>&1
		set /a "bat_avgskippedperfile=!bat_retval!*1">nul: 2>&1
		call "str_math.bat" "!bat_avgskippedperfile!/1000">nul: 2>&1
		set bat_avgskippedperfile=!bat_retval!
	)

	set /a bat_totalframes="!bat_filecount_camera! * 256"
	set /a bat_framespersec=!bat_totalframes!*1000 / (!bat_totalsecs!/1000)


	echo.
	echo     Camera:                   !bat_camera_prev!
	echo     Source Directory:         !bat_sourcedir!
	echo     Frames per FF file:       256 video frames
	echo     Frame rate:               !bat_camera_framerate:~0,-2!.!bat_camera_framerate:~-2! frames per second
	echo     Proper time for FF file:  !bat_fps:~0,-3!.!bat_fps:~-3! seconds
	echo.
	echo     First File: !bat_skipped_firstfile!  Last File: !bat_skipped_lastfile!
	echo     Total time: !bat_totalsecs:~0,-3!.!bat_totalsecs:~-3! secs   or  !bat_totalmin:~0,-3!.!bat_totalmin:~-3! minutes   or   !bat_totalhrs:~0,-3!.!bat_totalhrs:~-3! hours
	echo     Total Files: !bat_filecount_camera!
	echo     Total skipped: !bat_skippedtotal!   Avg dropped frames per FF file: !bat_avgskippedperfile!   Avg dropped frames per min: !bat_avgskipped!
	echo     Total frames: !bat_totalframes!   Avg Captured Frames per sec:   !bat_framespersec:~0,-3!.!bat_framespersec:~-3!
	echo.

	echo.>>"!bat_skippedframes_tempfile!"
	echo.SkippedFrames.bat Camera Summary>>"!bat_skippedframes_tempfile!"
	echo.>>"!bat_skippedframes_tempfile!"
	echo.     Camera:                   !bat_camera_prev!>>"!bat_skippedframes_tempfile!"
	echo.     Source Directory:         !bat_sourcedir!>>"!bat_skippedframes_tempfile!"
	echo.     Frames per FF file:       256 video frames>>"!bat_skippedframes_tempfile!"
	echo.     Frame rate:               !bat_camera_framerate:~0,-2!.!bat_camera_framerate:~-2! frames per second>>"!bat_skippedframes_tempfile!"
	echo.     Proper time for FF file:  !bat_fps:~0,-3!.!bat_fps:~-3! seconds>>"!bat_skippedframes_tempfile!"
	echo.>>"!bat_skippedframes_tempfile!"
	echo.     First File: !bat_skipped_firstfile!  Last File: !bat_skipped_lastfile!>>"!bat_skippedframes_tempfile!"
	echo.     Total time: !bat_totalsecs:~0,-3!.!bat_totalsecs:~-3! secs   or  !bat_totalmin:~0,-3!.!bat_totalmin:~-3! minutes   or   !bat_totalhrs:~0,-3!.!bat_totalhrs:~-3! hours>>"!bat_skippedframes_tempfile!"
	echo.     Total Files: !bat_filecount_camera!>>"!bat_skippedframes_tempfile!"
	echo.     Total skipped: !bat_skippedtotal!   Avg dropped frames per FF file: !bat_avgskippedperfile!   Avg dropped frames per min:   !bat_avgskipped!>>"!bat_skippedframes_tempfile!"
	echo.     Total frames: !bat_totalframes!   Avg Captured Frames per sec:   !bat_framespersec:~0,-3!.!bat_framespersec:~-3!>>"!bat_skippedframes_tempfile!"
	echo.>>"!bat_skippedframes_tempfile!"
	!bat_echolog!
	
:CAMERASUMMARY_END
!bat_return!





:GETFPS [in] bat_camera [out] bat_fps
!bat_pushlog! call !bat_batchfile!:GETFPS %*
	!bat_log! This routine is misnamed.  It does not return FPS.  Instead, it
	!bat_log! returns number of seconds per FF file using the following 
	!bat_log! formula: [256000000 / 2997]+5 = 85423
	!bat_log! Then it truncates to: 8542
	call :GETCAMERAENTRY %~1
	call :READCAMERAFILE "!bat_camerafile!"
	set /a "bat_fps=256000000/!bat_camera_framerate!+5"
	set bat_fps=!bat_fps:~0,-1!
!bat_poplog! return-!bat_batchfile!:GETFPS [bat_fps=!bat_fps!]
!BAT_LOG!
!bat_return!






:GETCAMERAENTRY [in] bat_camera [out] bat_camerafile
	set bat_retval=
	set bat_lat=
	set bat_long=
	set bat_height=
	set bat_camerafile=
	set bat_sitecode=
	set bat_sitename=

	for /f "usebackq tokens=1-7 skip=2" %%b in (`find /i "%~1   " "!bat_caldir!\CameraSites-%~1.txt"`) do (
		set bat_lat=%%c
		set bat_long=%%d
		set bat_height=%%e
		set bat_camerafile=!bat_caldir!\%%f
		set bat_sitecode=%%g
		set bat_sitename=%%h
	)
	set bat_retval=!bat_camerafile!
:goto :EOF






:READCAMERAFILE [in] bat_camerafile [out] bat_camera_framerate
	set bat_retval=
	set bat_camera_framerate=

	for /f "usebackq tokens=1-7 skip=2" %%c in (`find /i "frame rate" "!bat_camerafile!"`) do (
		set bat_camera_framerate=%%g
	)
	
	for /f "usebackq tokens=1,2 delims=." %%c in ('!bat_camera_framerate!') do (
		set bat_left=%%c
		set bat_right=%%d
	)

	set bat_camera_framerate=!bat_left!!bat_right!
	set bat_retval=!bat_camera_framerate!
!bat_return!







:SETSTARS [in] bat_skipcount2
	set bat_temp=!bat_stars:~0,%1!
	if !bat_skipcount! GEQ 256 (
		set bat_temp=!bat_temp! ^(!bat_skipcount!^)
	)
	set bat_msg=!bat_msg!	!bat_temp!
!bat_return!






	rem Usage:
	rem  "skippedFrames.bat" /camera 213 "c:\cam213\CAMS\CapturedFiles\2012_08_11_03_44_55" /v /ok
:PARSEARGS
	set bat_verbose=false
	set bat_OK=false

:PARSEARGS2
	if "%~1" equ "" goto :PARSEARGS_END

	echo.%~1|find /i "/camera">nul
	if !errorlevel! equ 0 (
		set bat_camera=%~2
		shift
		shift
		goto :PARSEARGS2
	)

	echo.%~1|find /i "/v">nul
	if !errorlevel! equ 0 (
		set bat_verbose=true
		shift
		goto :PARSEARGS2
	)

	echo.%~1|find /i "/ok">nul
	if !errorlevel! equ 0 (
		set bat_OK=true
		shift
		goto :PARSEARGS2
	)

	set bat_sourcedir=%~1
	shift
	
	goto :PARSEARGS2

:PARSEARGS_END
rem !bat_echo! return-!bat_batchfile!:PARSEARGS [bat_camera=!bat_camera!;
rem !bat_echo! '                                   bat_OK=!bat_OK!
rem !bat_echo! '                                   bat_verbose=!bat_verbose!
rem !bat_echo! '                                   bat_sourcedir=!bat_sourcedir!]
!bat_return!






:HELP
	echo.
	echo %~n0
	echo.
	echo Usage: %~n0  [/camera "<camera>"]  "<directory>"   [/v] [/ok]
	echo.
	echo Displays the dropped frames from the specified capture session (directory)
	echo.
	echo    where /v    means verbose mode, which lists the files that have skipped frames
	echo          /ok   means to list the files that don't have skipped frames
	echo.
exit /b -99
