 @echo off
setlocal enableextensions enabledelayedexpansion

	rem NEEDS:
	rem       - If no Submit dir exists, then abort
	

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	Flowchart:
		- list all the email files under the SubmissionFiles directory tree
		- Copy all those "emailfiles\*.*" files to ".\cams\temp"
		- zip the files up into a single zip file



:SETUP

	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
	)

	if not defined bat_autonomous (
		!bat_echolog! Running in normal [non-autonomous] mode
	) else (
		!bat_echolog! Running in autonomous mode
	)

	set bat_startlocation=!bat_exedir!
	set bat_startdrive=!bat_exedrive!
	set bat_caldir=%bat_startlocation%\Cal

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!


:MAIN
!bat_log! [GOTO !BAT_BATCHFILE!:MAIN] %*
	rem start the execution of the detection pass in background priority

	!bat_logexeclog! set bat_
	
	call :PARSEARGS %*

	call :GETDIRNAMES %*
	if "!bat_returncode!" neq "0" (
		set bat_recent_error_msg=13. ERROR - submit.email.bat failed.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END
	)
	
	!bat_logexeclog! set bat_
	!bat_log!
	!bat_log! =====================================
	!bat_log!


:MAIN_END
!bat_log! [END !bat_batchfile!:MAIN_END] 
goto :DONE




:GETDIRNAMES
!bat_pushlog! [CALL !bat_batchfile!:GETDIRNAMES] %*
	!bat_logexeclog! set bat_returncode=0

	!bat_echolog! Loop to iterate through all directory names under the ".\SubmissionFiles\[date/time]\EmailFiles".
	!bat_echolog! Then, extract the [date/time] and use that as the target dir for the copy.
	!bat_echolog!

	rem Note: possibly use the following command instead of `dir /ad /s/b`:
	rem    forfiles /p ".\SubmissionFiles" /m "emailfiles" /s /c "cmd /c echo @path"
	rem or, we could use the /d option to include only those directories that have a 
	rem Modified Date within the last -n days
	rem    forfiles /p ".\SubmissionFiles" /m "emailfiles" /s /c "cmd /c echo @path" /d -7

		rem Set bat_loop=continue in order to process the loop. 
		rem Otherwise, some part of the loop changed the value to 'break', thus
		rem causing the remainder of the loop to be skipped.
	set bat_loop=continue
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissiondir!\EmailFiles*" /ad /s/b /on `^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_submissiondir!\EmailFiles*" /ad /s/b /on `) do (
		if /i "!bat_loop!" equ "break" (
			rem goto :GETDIRNAMES_BREAK
		) else (
			if /i "%%~nxa" equ "displayJPEGS" (
				rem goto :GETDIRNAMES_BREAK
			) else (
				if /i "%%~nxa" equ "gefdat" (
					rem goto :GETDIRNAMES_BREAK
				) else (
					!bat_log! a=%%a

					set bat_temp=%%a
					!bat_logexeclog! set bat_emailfilesdir=%%~a::
					!bat_logexeclog! set bat_emailfilesdir=!bat_emailfilesdir:\::=!
					!bat_logexeclog! set bat_emailfilesdir=!bat_emailfilesdir:::=!

					!bat_logexeclog! set bat_temp=!bat_emailfilesdir!
						rem Results in bat_basedir
					call :GETDATEDIR "%%~a" "!bat_emailfilesdir!"

					!bat_logexeclog! set bat_targetbasedir=!bat_startlocation!\Submitted\!bat_dirdate!_!bat_camera!_!bat_capturedtime!
					!bat_logexeclog! set bat_targetdir=!bat_targetbasedir!\!bat_camera!


					if "!bat_targetdir!" equ "" (
						!bat_logexeclog! set bat_returncode=1
						call :GETDIRERROR
						!bat_logexeclog! set bat_loop=break
					) else (
						call :CREATEDIRS


							rem Read the detect file [if confirmed doesn't exist, then
							rem use archived] to get FFdir, caldr, meteorcount, 
							rem cal dir, and cal name. 
						call :READFILE
						set bat_temp=!bat_returncode!
						!bat_echolog! bat_returncode=!bat_temp!, bat_returncode=!bat_returncode!, bat_retval=!bat_retval!

						!bat_log!
						!bat_logexeclog! xcopy "!bat_basedir!\EmailFiles\*.*" "!bat_targetdir!\EmailFiles" /s/e/v/c/i/f/h/r/y
						!bat_log!

						for /f "usebackq tokens=*" %%a in (`dir "!bat_emailfilesdir!\cal*" /ad /s/b`) do (
							!bat_logexeclog! xcopy "%%a\*.txt" "!bat_targetdir!\Cal" /i/v/c/f/h/r/y
						)
					)
				)
			)
		)
	)& rem for...
	!bat_poplog!

!bat_poplog! [RETURN !bat_batchfile!:GETDIRNAMES] [!bat_emailfilesdir!]
!bat_log!
!bat_return!




:READFILE
!bat_pushlog! [CALL !bat_batchfile!:READFILE] %*
	rem Loop to read the FTPdetectinfo.txt file.
	set bat_returncode=-1

		rem GetDetectFile.bat and check results...
	set bat_readfile=
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "bat_readfile" "!bat_emailfilesdir!" "!bat_capturedfilesdir!"

	!bat_echolog! if not defined bat_readfile ...
	if not defined bat_readfile (
		set bat_retval=failed
		set bat_returncode=11
			!bat_log!
			!bat_log! '    !bat_batchfile!:READFILE - ERROR - detect file not found in:
			!bat_log! '            "!bat_emailfilesdir!"
			!bat_log!

		!bat_poplog! exit /b !bat_returncode! [bat_returncode=!bat_returncode!, bat_filecount=!bat_filecount!]
		             exit /b !bat_returncode!
		goto :READFILE_END
	) else (
		!bat_log! '    OK - detect file is: !bat_readfile!
	)


	!bat_echolog! if not exist "!bat_readfile!" ...
	if not exist "!bat_readfile!" (
		!bat_log! echo [:READFILE] "!bat_readfile!" does not exist
			set bat_retval=failed
			set bat_returncode=12
			!bat_log!
			!bat_log! '    !bat_batchfile!:READFILE - ERROR - Cannot continue without a detect file:
			!bat_log! '            "!bat_readfile!"
			!bat_log!
			!bat_log! '    The files have already been moved... you will need to move 
			!bat_log! '    them back and start over after resolving the problems.
			!bat_log!
			!bat_log! '    !bat_batchfile!:READFILE - ERROR - "!bat_readfile!" does not exist

			!bat_poplog! exit /b !bat_returncode! [bat_returncode=!bat_returncode!, bat_filecount=!bat_filecount!]
						 exit /b !bat_returncode!
			goto :READFILE_END
	) else (
		!bat_log! '    OK - detect file exists: !bat_readfile!
	)

	!bat_log! bat_readfile=!bat_readfile!
rem	!bat_logexec! !bat_CALL! "ParseDir.bat" "!bat_readfile!" bat_submittedemaildir bat_submitteddetectfilename
rem	!bat_logexec! set bat_submitteddetectfile=!bat_targetdir!\!bat_submitteddetectfilename!
		
rem	!bat_logexec! move /y "!bat_readfile!" "!bat_targetdir!"
rem	!bat_logexec! set bat_readfile=!bat_submitteddetectfile!

	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0

	!bat_pushecho! METEOR COUNT
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "Meteor Count" "!bat_readfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETMETEORCOUNT bat_countscanned %%b
		!bat_echolog! Meteor Count=!bat_countscanned!
	)
	!bat_popecho! Meteor Count=!bat_countscanned!
	!bat_echolog!

	!bat_pushecho! FF DIR
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "FF  folder" "!bat_readfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETFFDIR "%%b"
	)
	!bat_popecho! "!bat_ffdir!"
	!bat_echolog!
	
	!bat_pushecho! CAL DIR
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "CAL folder" "!bat_readfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETCALDIR "%%b"
	)
	!bat_popecho! "!bat_caldir!
	!bat_echolog!
	
	!bat_pushecho! CalFileList
	set /a bat_linecount=0
	for /f "usebackq tokens=* skip=2" %%b in (`find /i ".txt" "!bat_readfile!"`) do (
		set bat_temp=%%b
		set bat_templine=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!

		set /a bat_linecount+=1

		if !bat_linecount! equ 1 (
			!bat_echolog! !bat_linecunt! equ 1 ...
			call :GETCALNAME "%%b"
		)
	)
	!bat_popecho!
	set bat_returncode=0



%bat_COMMENT_BEGIN%
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`type "!bat_readfile!"`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`type "!bat_readfile!"`) do (
		set bat_temp=%%a
		set bat_templine=%%a
		set bat_temp=!bat_temp:~0,5!

		set /a bat_linecount+=1
		if !bat_linecount! equ 1 (
			!bat_echolog! !bat_linecount! equ 1...
			call :GETMETEORCOUNT %%a
		) else (
			if !bat_linecount! equ 5 (
				!bat_echolog! !bat_linecount! equ 5 ...
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					!bat_echolog! !bat_linecount! equ 6 ...
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						!bat_echolog! !bat_linecount! equ 13 ...
						rem call :GETCAMERA
						set bat_fffilename=%%a
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							!bat_echolog! !bat_linecount! equ 14 ...
							call :GETCALNAME "%%a"
						) else (
							if /i "!bat_templine:~-5!" equ ".bin " (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)& rem for...
	!bat_poplog!
%BAT_COMMENT_END%

:READFILE_END
!bat_poplog! [RETURN !bat_batchfile!:READFILE] [bat_returncode=!bat_returncode!, bat_filecount=!bat_filecount!]
!bat_log!
!bat_return!






:CONTINUE
	!bat_log! start "FTP_Reprocess" /low "!bat_exedir_nonUS!\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%"
goto :DONE





:CREATEDIRS
!bat_pushlog! [CALL !bat_batchfile!:CREATEDIRS] %*
	rem usage: call :CREATEDIRS "!bat_dirname!"
	rem Creates the target dirs that it can, but some have to be done
	rem in the loop while reading the ftpdetectinfo.txt file
	!bat_logexeclog! md "!bat_targetdir!"
	!bat_logexeclog! md "!bat_targetdir!\EmailFiles\Cal-!bat_camera!"
!bat_poplog! [RETURN !bat_batchfile!:CREATEDIRS] [!bat_targetdir!]
!bat_log!
!bat_return!







:DELUNWANTED
!bat_pushlog! [CALL !bat_batchfile!:DELUNWANTED] %*

	!bat_pushlog! for /f "usebackq tokens=*" %%a in ^(`dir "%~1" /s/b /ad`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "%~1" /s/b /ad`) do (
		set bat_unwanteddir=%%~a
		set bat_unwanteddirname=%%~nxa

		!bat_log! '    Cleaning "!bat_unwanteddir!"
		
		set bat_temp_ok=yes
		if /i "!bat_unwanteddir!" equ "" (
			set bat_temp_ok=
		)

		if /i "!bat_unwanteddirname!" equ "" (
			set bat_temp_ok=
		)
		
		if defined bat_temp_ok (
			if "!bat_unwanteddirname!" equ "displayJPEGs" (
				if /i "!bat_unwanteddir!" neq "" (
					!bat_logexeclog! del /f /s /q "!bat_unwanteddir!\*.*"
					!bat_logexeclog! rd /s /q "!bat_unwanteddir!"
				)
			)

			if "!bat_unwanteddirname!" equ "gefdat" (
				if /i "!bat_unwanteddir!" neq "" (
					!bat_logexeclog! del /f /s /q "!bat_unwanteddir!\*.*"
					!bat_logexeclog! rd /s /q "!bat_unwanteddir!"
				)
			)

			if "!bat_unwanteddirname!" equ "movies" (
				if /i  "!bat_unwanteddir!" neq "" (
					!bat_logexeclog! del /f /s /q "!bat_unwanteddir!\*.*"
					!bat_logexeclog! rd /s /q "!bat_unwanteddir!"
				)
			)

			if exist "!bat_unwanteddir!\FFCorruptFilesLog*.*" (
				del /q /f "!bat_unwanteddir!\FFCorruptFilesLog*.*"
			)
			if exist "!bat_unwanteddir!\FTPdetectinfo_Case*.*" (
				del /q /f "!bat_unwanteddir!\FTPdetectinfo_Case*.*"
			)
			if exist "!bat_unwanteddir!\FFdirectorylisting_*.*" (
				del /q /f "!bat_unwanteddir!\FFdirectorylisting_*.*"
			)
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:STRIPHEADER] Dangerous command:del /q /f "!bat_unwanteddir!\FFCorruptFilesLog*.*"
		)
	)& rem for...
	!bat_poplog!

:DELUNWANTED_END
!bat_poplog! [RETURN !bat_batchfile!:DELUNWANTED] [bat_temp_ok=!bat_temp_ok!] [%*]
!bat_log!
	set bat_temp_ok=
!bat_return!




:ERR1
	!bat_log!
	!bat_log!
	!bat_log! '    "%cd%\ArchivedFiles\%ftp_archiveddir%" already exists. Do you want to
	!bat_log! '    continue to overwrite the existing files? [Y/N] Y
	goto :CONTINUE
	if not defined bat_autonomous (
		set /p retval=continue to overwrite the existing files? [Y/N] 
		if /i "%retval%" equ "y" goto :CONTINUE
	)
exit /b 1
goto :DONE



:GETCALDIR
!bat_pushlog! [CALL !bat_batchfile!:GETCALDIR] %*
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_poplog! [RETURN !bat_batchfile!:GETCALDIR] [!bat_caldir!]
!bat_log!
!bat_return!


	rem 
:GETCALNAME
	set bat_calfilename=%~1
!bat_log!
!bat_return!


:COPYCALFILE
	!bat_logexeclog! copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!"
!bat_log!
!bat_return!

:GETCAMERA
	set bat_camera=!bat_temp:~2,3!
!bat_log!
!bat_return!



:GETCAMERAFROMDETECT
!bat_pushlog! [CALL !bat_batchfile!.GETCAMERAFROMDETECT] [%*]
	
	for /f "usebackq tokens=*" %%b in (`dir "submissionfiles\!bat_dirdate!\ftpdetectinfo_scanned-!bat_camera!.txt" /s/b /a-d^|find /i "emailfiles"`) do (
		set bat_detectfile1=%%dpnxb
	)
	
	!bat_poplog! return-!bat_batchfile!.GETCAMERAFROMDETECT: [%*]   [camera=!bat_camera!] [!bat_detectfile1!]
	if "!bat_camera!" equ "" (
		!bat_log! '    ERROR: couldn't determine camera number
		if not defined bat_autonomous (
			pause
		)
	)
!bat_poplog! [RETURN !bat_batchfile!.GETCAMERAFROMDETECT] [%*] [camera=!bat_camera!]  []
!bat_log!
!bat_return!




:GETDATEDIR
!bat_pushlog! [CALL !bat_batchfile!:GETDATEDIR] [%*] %~1, %~dp1, %~nx1
	rem set bat_basedir=!bat_startlocation!\SubmissionFiles\!bat_dirdate!\!bat_camera!
	set bat_basedir=%~dp2::
	set bat_basedir=!bat_basedir:\::=!
	set bat_basedir=!bat_basedir:::=!
!bat_poplog! [RETURN !bat_batchfile!:GETDATEDIR] [bat_basedir=!bat_basedir!]
!bat_log!
!bat_return!



:GETDIRERROR
	!bat_pushlog!
		!bat_log! '    ERROR - one of these settings is bad:
		!bat_logexeclog! set bat_
	!bat_poplog!
!bat_log!
!bat_return!




:GETFFDIR
!bat_pushlog! [CALL !bat_batchfile!:GETFFDIR] %*
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_poplog! [RETURN!bat_batchfile!:GETFFDIR] [!bat_ffdir!]
!bat_log!
!bat_return!



:GETMETEORCOUNT
!bat_pushlog! [CALL !bat_batchfile!:GETMETEORCOUNT] %1, %2, %3, %4
	rem Usage: call :GETMETEORCOUNT Meteor Count = 000533

	set bat_temp=%3
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (
		set bat_countconfirmed=%%a
	)

	if not defined bat_countconfirmed (
		set bat_countconfirmed=0
	)

!bat_poplog! [RETURN !bat_batchfile!:GETMETEORCOUNT] [bat_countconfirmed=!bat_countconfirmed!]
!bat_log!
!bat_return!




:STRIPARCHHEADER
	rem Strips the header from the FTPdetectinfo_scanned-!bat_camera!.txt file.  
	rem The camera number and the meteor count are added to the 
	rem filename as follows:
	rem   FTPdetectinfo_scanned-[camera]-[meteor count].txt
	
!bat_return!



:STRIPCONFHEADER
	rem Strips the header from the FTPdetectinfo_confirmed-!bat_camera!.txt file found
	rem in the ConfirmedFiles directory.  The camera number and 
	rem the meteor count are added to the filename as follows:
	rem   FTPdetectinfo_confirmed-[camera]-[meteor count].txt
	
!bat_return!


:MOVEERROR
!bat_return!



:MOVEFILES

!bat_return!


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
							!bat_TITLE!
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
							!bat_TITLE!
EXIT /b 0





:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %~1, %~dp1, %~nx1, %~2, %~3

	set bat_temp=%~n3
	set bat_dirdate=%~n3
	set bat_dirdate=!bat_dirdate:~0,10!
	set bat_capturedtime=!bat_temp:~-8!
	set bat_mainfilter= 

	if "%~1" neq "" (
		set bat_mainfilter=^|find /i "!bat_dirdate!"
	)
	
	if "%~2" neq "" (
		set bat_camera=%~2
	) else (
		set /p bat_camera=Enter Camera number: 
	)

	if "%~3" neq "" (
		set bat_submissionfilesdir=%~3
	) else (
		set /p bat_submissionfilesdir=Enter SubmissionFiles directory :
	)

	set bat_submissiondir=!bat_submissionfilesdir!\!bat_camera!
	
	!bat_log! bat_camera=!bat_camera!
	!bat_log! bat_dirdate=!bat_dirdate!
	!bat_log! bat_submissionfilesdir=!bat_submissionfilesdir!

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [!bat_dirdate!, !bat_camera!, !bat_submissionfilesdir!, !bat_submissiondir!]
!bat_log!
!bat_return!



			
			
			
:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo Usage: %0
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to COPY [not move] the ".\SubmissionFiles\[date]\EmailFiles\" 
	echo into the ".\Submitted\[date]" directory tree.  What you'll have left is a bunch of 
	echo directories (dates of captured/processed/confirmed files).
	echo.
	echo The organization of the target files will be as follows:
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\EmailFiles       contains:
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_confirmed.txt
	echo 							This is the one from the \cams\ConfirmedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_scanned.txt
	echo 							This is the one from the \cams\ArchivedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- CameraTimeOffsets.txt			renamed to CameraTimeOffsets_Brentwood_2011_08_01_05_00_19.txt
	echo 		- LASTSETTINGS.txt			renamed to LASTSETTINGS_Brentwood_2011_08_01_05_00_19.txt
	echo 		- ReprocessParameters.txt		renamed to ReprocessParameters_Brentwood_2011_08_01_05_00_19.txt
	echo 		- \cams\cal\CameraSites.txt		renamed to CameraSites_Brentwood_2011_08_01.txt
	echo 		- \cams\cal\CAL213_20110801_050019_514.txt
	echo.				 
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\BinFiles
	echo 		- contains the FF*.bin files
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\AviFiles
	echo.
	echo After the script verifies the movement of all these files, it is ready to create a
	echo zip file of everything in the ".\SubmissionFiles\<datetime>\EmailFiles" so that 
	echo they can be sent via email.
	echo.
	echo Most of this can be automated in this script in batch mode. We can't make a 
	echo DVD unattended though and that will need to be done manually.
	echo.
	echo To make the DVD, we copy ".\cams\SubmissionFiles\*.*" to the DVD burner.
	echo It might work better with RoboCopy, since I think it might support filling
	echo up a DVD and then continuing, but I'm not quite sure.
	echo.
	echo Once the DVD is burned, the files should be moved to ".\cams\SubmittedFiles\..." 
	echo.
	echo After a period of time, the specific ".\cams\SubmittedFiles\<datetime> directories can 
	echo be purged from the hard drive to make room for newer files. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
	echo One issue to resolve is when there is an ArchivedFiles\^<date/time^> directory but no 
	echo matching ConfirmedFiles^<date/time^> directory.  This could have been caused by
	echo not being able to complete the processing due to some bug or corrupt files.  In that
	echo case, we just submit the files from the ArchivedFiles\^<date/time^> directory and 
	echo notate that in the readme.txt file in the directory.
	echo.
	echo Also, we need to start copying the necessary CAL and other files into the ArchivedFiles 
	echo directory as part of the ftp_reprocess.bat steps.  Perhaps we do that by calling
	echo a "complete_reprocessing.bat" routine.  Such a routine should be able to be run at
	echo anytime after FTP_Reprocess.exe is completed (or even while it is running).
	echo.
exit /b -99


:DONE
	!bat_popecho!
	!bat_echolog! 'Done with %~nx0 %*
	!bat_echolog! errorlevel=!bat_returncode!
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!
